;################################################################################
;#										#
;# chipbasic2m - mobile single chip basic computer with ATMega 644		#
;# german translations								#
;# copyright (c) 2006-8 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;-------------------------------------------------------------------------------
;common text
;-------------------------------------------------------------------------------
text_yn:	.db " ENTER=Ja ESC=Nein ",0

;------------------------------------------------------------------------------
;graphical menues
;----------------012345678901234567890-----------------------------------------
menudata_main:	.db	"                    "
.include	"lang/de/stable.inc"			;main menu
;meas menu
menu_stab1:

		.db	"      Messen        "
.include	"lang/de/stable1.inc"			;meas menu
;game menu
menu_stab2:

		.db	"      Spiele        "
.include	"lang/de/stable2.inc"			;game menu
menu_stab3:

;------------------------------------------------------------------------------
;intro screen
;----------------012345678901234567890-----------------------------------------
text_intro_1:	.db " Taste dreht Anzeige ",0


;------------------------------------------------------------------------------
;configure screen
;----------------012345678901234567890-----------------------------------------
text_conf_1:	.db " Konfiguration ",0

configdata_vid:	.db "Video:   PAL      "
		.db "Video:   NTSC     "

configdata_snd:	.db "Audio:   Stumm    "
		.db "Audio:   Ein      "
		
configdata_spi:	.db "SPI:     156 kHz  "
		.db "SPI:     5 MHz    "
	
configdata_i2c:	.db "I2C:     100 kHz  "
		.db "I2C:     400 kHz  "
		
configdata_ser:	.db "Seriell: 1200 Bps "
		.db "Seriell: 2400 Bps "
		.db "Seriell: 4800 Bps "
		.db "Seriell: 9600 Bps "
		.db "Seriell: 19200 Bps"
		.db "Seriell: 31250 Bps"
		.db "Seriell: 38400 Bps"
		.db "Seriell: 57600 Bps"
		
;-------------------------------------------------------------------------------
;file menu
;-------------------------------------------------------------------------------		           	
menudata_file:	.db "      Datei         "
		.db "Datei loeschen    "
		.db "Image laden       "
		.db "Image speichern   "
		.db "Bildschirm senden "
		.db "Modul formatieren "


text_file_1:	.db "      Wirklich     ",0				
text_file_2:	.db "    Formatieren?   ",0	
text_file_3:	.db "     Links=Ja 	",0
text_file_4:	.db "Formatieren...",0,0

;-------------------------------------------------------------------------------
;filesys
;-------------------------------------------------------------------------------
fsys_ndtext:	.db " Neue Logikdatei     ",0
fsys_natext:	.db " Neue Kurvendatei    ",0
fsys_sdtext:	.db " Logikdatei senden   ",0
fsys_satext:	.db " Kurvendatei senden  ",0

text_fsys_1:	.db "Lade Daten...",0
text_fsys_2:	.db "Speichere Daten...",0,0
text_fsys_3:	.db " Datei l",0x89,"schen ",0	
text_fsys_4:	.db "    L",0x89,"schen?    ",0,0
text_fsys_5:	.db " Programm ",0,0
text_fsys_6:	.db " speichern ",0
text_fsys_7:	.db " laden ",0
text_fsys_10:	.db " GPS speichern ",0
text_fsys_11:	.db " Daten speichern ",0
text_fsys_14:	.db " GPS laden ",0
text_fsys_15:	.db " Daten laden ",0

;-------------------------------------------------------------------------------
;user menu
;-------------------------------------------------------------------------------
user_menudata:	.db "Programm-Funktionen "
		.db "Programm starten  "
		.db "von Karte laden   "
		.db "Auf Karte speich. "
		.db "Seriell laden     "
		.db "Seriell speichern "

user_starthead:	.db "   Starte Programm   ",0
user_sendhead:	.db "   Sende Programm    ",0
user_recvhead:	.db "  Empfange Programm  ",0
user_savehead:	.db " Speichere Programm  ",0
user_loadhead:	.db "    Lade Programm    ",0

user_text_1:	.db "X-Modem (Empfangen)",0	
user_text_2:	.db "X-Modem (Senden)",0,0	

;-------------------------------------------------------------------------------
;breakout game
;-------------------------------------------------------------------------------
bout_text_1:	.db "Bild:",0
bout_text_2:	.db "PUNKTE:",0

;-------------------------------------------------------------------------------
;puzzle game
;-------------------------------------------------------------------------------
puzz_text_1:	.db " Geschafft ! ",0	
puzz_text_2:	.db "Puzzle ",0
puzz_text_3:	.db "  Zuege:",0,0

;-------------------------------------------------------------------------------
;GPS functions
;-------------------------------------------------------------------------------
gps_ngroupt:	.db	" Neue Gruppe (12Z.)  ",0		
gps_nogrpt:	.db	"Keine Gruppe",0,0
gps_txthd:	.db	"GRP=",0,0
gps_dathd:	.db	"DAT=",0,0
gps_tpost:	.db	"#END",0x0d,0x0a,0,0
gps_tpre:	.db	"$GPSLIST=",0


menudata_glog:	.db "  GPS Logliste      "
		.db "Liste senden      "
		.db "Liste leeren      "
		.db "Liste laden       "
		.db "Liste speichern   "
		.db "                  "	
							
gps_text_1:	.db "BREITE",0,0
gps_text_2:	.db "LAENGE",0,0
gps_text_3:	.db "GESCHW",0,0
gps_text_4:	.db " Daten L",0x89,"schen? ",0,0

;------------------------------------------------------------------------
;gps2 functions
;------------------------------------------------------------------------	
menudata_gps2:	.db "  GPS Ziel-Liste    "
		.db "Ziel waehlen      "
		.db "Position als Ziel "
		.db "Koordinaten eing. "
		.db "                  "
		.db "                  "
		
gps2_ftext1:	.db "Ziel waehlen         ",0	
gps2_ftext2:	.db "Akt. Position -> Ziel",0	
gps2_ftext3:	.db "Koordinaten manuell  ",0


gps2_ntext1:	.db "Name des Zieles      ",0
gps2_ntext2:	.db "Breite (-)DDD.dddddd ",0
gps2_ntext3:	.db "Laenge (-)DDD.dddddd ",0

gps2_text_1:	.db "Ziel",0,0
gps2_text_2:	.db "DIST",0,0	
gps2_text_3:	.db "KURS  RICHTUNG  KARTE",0
gps2_text_4:	.db 

;------------------------------------------------------------------------
;counter
;------------------------------------------------------------------------
count_swstext1:	.db "Z",0x88,"hlspeicher sichern ",0
count_sstext:	.db "Z",0x88,"hleintrag Name     ",0
count_text_1:	.db "Z",0x88,"hler",0,0
count_text_2:	.db "E",0

;-------------------------------------------------------------------------------
;curve
;--------------------##################----------------------------------------
mincu_dmain:	.db "    Mini-Curve      "
		.db "Messung starten   "
		.db "Samplerate:       "
		.db "Trigger:          "
		.db "Daten anzeigen    "
		.db "Datei             "

mincu_dfile:	.db "   Curve-Datei      "
		.db "Datei speichern   "
		.db "Datei laden       "
		.db "Senden (XMODEM)   "
		.db "Empfangen (XMODEM)"
		.db "                  "
		
mincu_text_1:	.db "Aufzeichnung...",0		
		


;-------------------------------------------------------------------------------
; mini la
;--------------------##################----------------------------------------
minla_dmain:	.db "      Mini-LA       "
		.db "Messung starten   "
		.db "Samplerate:       "
		.db "Trigger:          "
		.db "Daten anzeigen    "
		.db "Datei             "

minla_dfile:	.db " Mini-LA Datei      "
		.db "Datei speichern   "
		.db "Datei laden       "
		.db "Senden (XMODEM)   "
		.db "Empfangen (XMODEM)"
		.db "                  "	
		
minla_cdata_m:	.db 0xcf," E0  "
		.db 0xce," E0  "
		.db 0xcf," E1  "
		.db 0xce," E1  "
		.db "Inst. "
		.db "Stop  "		


;------------------------------------------------------------------------------
;thermometer
;------------------------------------------------------------------------------
thermo_text_1:	.db " Thermometer ",0
thermo_text_2:	.db " Kein Sensor ",0
thermo_text_3:	.db "Korrekturwert",0	


;------------------------------------------------------------------------------
;time meas
;------------------------------------------------------------------------------
time_mtext:	.db 0xcf,"E0 > ",0xce,"E0",0	;pos. pulse A
		.db 0xce,"E0 > ",0xcf,"E0",0	;neg. pulse A
		.db 0xcf,"E0 > ",0xcf,"E1",0	;dly rising
		.db 0xce,"E0 > ",0xce,"E1",0	;dly falling

time_stext1:	.db "Inaktiv",0	;inactive
time_stext2:	.db "Wartet ",0 ;waits for trigger
time_stext3:	.db "Messung",0 ;starts meas
time_stext4:	.db "Abbruch",0 ;canceled		
				
time_text_1:	.db " Zeitmessung ",0
time_text_2:	.db "Mode",0,0
time_text_3:	.db "Status",0,0
time_text_4:	.db "Zeit",0,0
		
		
;------------------------------------------------------------------------------
;voltmeter
;------------------------------------------------------------------------------
volt_text_1:	.db "Voltmeter",0	


;------------------------------------------------------------------------------
;timer
;------------------------------------------------------------------------------
menudata_timer:	.db "       Uhr          "
		.db " Stopp-Uhr        "
		.db " Wecker           "
		.db " Uhr stellen      "
		.db "                  "
		.db "                  "

menudata_times:	.db "        Uhr         "
		.db "Uhrzeit stellen   "
		.db "Datum einstellen  "
		.db "nach GPS stellen  "
		.db "Stunde +-         "
		.db "                  "

timer_sttext:	.db " Uhrzeit (hhmmss)    ",0
timer_sdtext:	.db " Datum (ttmmjj)      ",0
timer_satext:	.db " Weckzeit (hhmm)     ",0
timer_sstext:	.db " Zeiteintrag Name    ",0

timer_swstext1:	.db "Zwischenzeit sichern ",0
timer_swstext2:	.db "Messwert sichern     ",0

timer_text_1:	.db "Warte auf GPS ...",0
timer_text_2:	.db "Stunde verstellen",0
timer_text_3:	.db "Wecker",0,0
timer_text_4:	.db "Weckzeit",0,0
timer_text_5:	.db "Stopp-Uhr",0
timer_text_6:	.db "Zeit",0,0
timer_text_7:	.db "Zwischenzeit",0,0



						