;################################################################################
;#										#
;# libeep - EEPROM R/W library for ATmega controllers				#
;# copyright (c) 2007-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
; read one byte (tempreg1) from EEPROM memory (Y+)
;------------------------------------------------------------------------------
libeep_read:	andi	YH,0x07		
libeep_read1:	sbic	EECR,EEPE
		rjmp	libeep_read1
		out	EEARH,YH
		out	EEARL,YL
		sbi	EECR,EERE
		in	tempreg1,EEDR
		adiw	YL,1
		ret				;thats all

;------------------------------------------------------------------------------
; write one byte (tempreg1) to EEPROM memory (Y+)
;------------------------------------------------------------------------------
libeep_write:	andi	YH,0x07		
libeep_write1:	sbic	EECR,EEPE		;wait for EEPROM ready
		rjmp	libeep_write1
		out	EEARH,YH
		out	EEARL,YL
		sbi	EECR,EERE
		in	tempreg5,EEDR
		cp	tempreg5,tempreg1
		brne	libeep_write2
		adiw	YL,1
		ret	
		
libeep_write2:	out	EEDR,tempreg1		;write byte
		cli
		sbi	EECR,EEMPE
		sbi	EECR,EEPE
		sei
libeep_write4:	sbic	EECR,EEPE		;verify
		rjmp	libeep_write4
		adiw	YL,1
		ret

;------------------------------------------------------------------------------
; read XL bytes from EEPROM (Y+) memory to Z+
;------------------------------------------------------------------------------
libeep_get:	push	XL
libeep_get1:	rcall	libeep_read			;get byte
		st	Z+,tempreg1
		dec	XL
		brne	libeep_get1
		pop	XL
		ret					

;------------------------------------------------------------------------------
; store XL bytes from Z+ to EEPROM (Y+) memory
;------------------------------------------------------------------------------
libeep_put:    	push	XL
libeep_put1:	ld	tempreg1,Z+
		rcall	libeep_write		;write byte
		dec	XL
		brne	libeep_put1
		pop	XL
		ret					

