;################################################################################
;#										#
;# libmio - multi i/o for ATMega644 version 0.40				#
;# copyright (c) 2005-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 2 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;uncomment next line to enable the whole library if avr_libmake is not used
;.set	use_libmio_all	= 1

.def	libmio_cur_x	= r10
.def	libmio_cur_y	= r11

.equ	vpin	= PIND
.equ	vport   = PORTD
.equ	vidp	= 4
.equ	lcddata = PORTA
.equ	lcdctrl = PORTC
.equ	lcdp_0	= PORTD
.equ	lcdbit0	= 6
.equ	lcdp_1	= PORTC
.equ	lcdbit1	= 4
.equ	lcd_cs1 = 7
.equ	lcd_cs2 = 6
.equ	lcd_e	= 5
.equ	lcd_di	= 3
.equ	K1port	= PIND
.equ	K2port 	= PINB
.equ	key_esc	= 3
.equ	key_ent = 2
.equ	key_up	= 0
.equ	key_down = 1
.equ	key_left = 2
.equ	key_right = 3

;--------------------------------------------------------------------------------
; user definitions
;--------------------------------------------------------------------------------
.equ	libmio_hslen = 90
.equ	libmio_hstart = 150

.equ	libmio_cols = 30
.equ	libmio_ecols = 35
.equ	libmio_rows = 23
.equ	libmio_pixel_rows = 230
.equ	libmio_pixel_rm2 = 228

.equ	libmio_vstart_n = 227
.equ	libmio_vstop_n = 233
.equ	libmio_counter_n = 1271

.equ	libmio_vstart_p = 250
.equ	libmio_vstop_p = 255
.equ	libmio_counter_p = 1279

.equ	libmio_rampos_l	= libmio_ram
.equ	libmio_rampos_h = libmio_ram+1
.equ	libmio_line_l	= libmio_ram+2
.equ	libmio_line_h	= libmio_ram+3
.equ	libmio_sysconf	= libmio_ram+4
.equ	libmio_font	= libmio_ram+5
.equ	libmio_cline 	= libmio_ram+6
.equ	libmio_tpre	= libmio_ram+7
.equ	libmio_frames	= libmio_ram+8
.equ	libmio_keybits	= libmio_ram+9

.equ	libmio_lcdpage	= libmio_ram+10
.equ	libmio_kbdshift	= libmio_ram+11
.equ 	libmio_kbdstate	= libmio_ram+12
.equ	libmio_lcdrow	= libmio_ram+13
.equ	libmio_keycode	= libmio_ram+14
.equ	libmio_lastkey	= libmio_ram+15

.equ	libmio_wpos_l	= libmio_ram+16
.equ	libmio_wpos_h	= libmio_ram+17
.equ	libmio_woff_l	= libmio_ram+18
.equ	libmio_woff_h	= libmio_ram+19
.equ	libmio_env	= libmio_ram+20
.equ	libmio_note_val	= libmio_ram+21

.equ	libmio_rand1	= libmio_ram+22
.equ	libmio_rand2	= libmio_ram+23
.equ	libmio_rand3	= libmio_ram+24
.equ	libmio_rand4	= libmio_ram+25
.equ	libmio_time0	= libmio_ram+26
.equ	libmio_time_l	= libmio_ram+27
.equ	libmio_time_h	= libmio_ram+28
.equ	libmio_tcorr	= libmio_ram+29
.equ	libmio_tdat	= libmio_ram+30
.equ	libmio_rcnt	= libmio_ram+31
.equ	libmio_rdat	= libmio_ram+32
.equ	libmio_config	= libmio_ram+33
.equ	libmio_channel  = libmio_ram+34
.equ	libmio_lpos	= libmio_ram+35
.equ	libmio_color	= libmio_ram+36
.equ	libmio_kflags	= libmio_ram+37
.equ	libmio_fileno	= libmio_ram+38
.equ	libmio_wavtab	= libmio_ram+39
.equ	libmio_snd	= libmio_ram+40
.equ	libmio_tstat	= libmio_ram+41
.equ	libmio_envv	= libmio_ram+42
.equ	libmio_seqstat	= libmio_ram+43
.equ	libmio_tprog	= libmio_ram+47
.equ	libmio_prog	= libmio_ram+50
.equ	libmio_tsl	= libmio_ram+51
.equ	libmio_lastmenu	= libmio_ram+53
.equ	libmio_tsh	= libmio_ram+54
.equ	libmio_tmsl	= libmio_ram+56
.equ	libmio_tmsh	= libmio_ram+57
.equ	libmio_tptr	= libmio_ram+58
.equ	libmio_krc	= libmio_ram+59
.equ	libmio_oldkey	= libmio_ram+60
.equ	libmio_rtc	= libmio_ram+61
.equ	libmio_bcsrcx	= libmio_ram+62
.equ	libmio_bcdx	= libmio_ram+63
.equ	libmio_bcdestx	= libmio_ram+64
.equ	libmio_bcsrcy	= libmio_ram+65
.equ	libmio_bcdy	= libmio_ram+66
.equ	libmio_bcdesty	= libmio_ram+67
.equ	libmio_bcmode	= libmio_ram+68
.equ	libmio_dfpages	= libmio_ram+69
.equ	libmio_dfptype	= libmio_ram+70
.equ	libmio_memtype	= libmio_ram+71
.equ	libmio_seqspeed	= libmio_ram+72
.equ	libmio_seqcount = libmio_ram+73
.equ	libmio_seql	= libmio_ram+74
.equ	libmio_seqh	= libmio_ram+75
.equ	libmio_seqal	= libmio_ram+76
.equ	libmio_seqah	= libmio_ram+77
.equ	libmio_seqbl	= libmio_ram+78
.equ	libmio_seqbh	= libmio_ram+79

;only offsets
.equ	lmo_rampos_l	= 0
.equ	lmo_rampos_h 	= 1
.equ	lmo_line_l	= 2
.equ	lmo_line_h	= 3
.equ	lmo_sysconf	= 4
.equ	lmo_font	= 5
.equ	lmo_cline 	= 6
.equ	lmo_tpre	= 7
.equ	lmo_frames	= 8
.equ	lmo_keybits	= 9

.equ	lmo_lcdpage	= 10
.equ	lmo_kbdshift	= 11
.equ 	lmo_kbdstate	= 12
.equ	lmo_lcdrow	= 13
.equ	lmo_keycode	= 14
.equ	lmo_lastkey	= 15

.equ	lmo_wpos_l	= 16
.equ	lmo_wpos_h	= 17
.equ	lmo_woff_l	= 18
.equ	lmo_woff_h	= 19
.equ	lmo_env		= 20
.equ	lmo_note_val	= 21

.equ	lmo_rand1	= 22
.equ	lmo_rand2	= 23
.equ	lmo_rand3	= 24
.equ	lmo_rand4	= 25
.equ	lmo_time0	= 26
.equ	lmo_time_l	= 27
.equ	lmo_time_h	= 28
.equ	lmo_tcorr	= 29
.equ	lmo_tdat	= 30
.equ	lmo_rcnt	= 31
.equ	lmo_rdat	= 32
.equ	lmo_config	= 33
.equ	lmo_channel  	= 34
.equ	lmo_lpos	= 35
.equ	lmo_color	= 36
.equ	lmo_kflags	= 37
.equ	lmo_fileno	= 38
.equ	lmo_wavtab	= 39
.equ	lmo_snd		= 40
.equ	lmo_tstat	= 41
.equ	lmo_envv	= 42
.equ	lmo_seqstat	= 43
.equ	lmo_tprog	= 47
.equ	lmo_prog	= 50
.equ	lmo_tsl		= 51
.equ	lmo_lastmenu	= 53
.equ	lmo_tsh		= 54
.equ	lmo_tmsl	= 56
.equ	lmo_tmsh	= 57
.equ	lmo_tptr	= 58
.equ	lmo_krc		= 59
.equ	lmo_oldkey	= 60
.equ	lmo_rtc		= 61
.equ	lmo_bcsrcx	= 62
.equ	lmo_bcdx	= 63
.equ	lmo_bcdestx	= 64
.equ	lmo_bcsrcy	= 65
.equ	lmo_bcdy	= 66
.equ	lmo_bcdesty	= 67
.equ	lmo_bcmode	= 68
.equ	lmo_dfpages	= 69
.equ	lmo_dfptype	= 70
.equ	lmo_memtype	= 71
.equ	lmo_seqspeed	= 72
.equ	lmo_seqcount	= 73
.equ	lmo_seql	= 74
.equ	lmo_seqh	= 75
.equ	lmo_seqal	= 76
.equ	lmo_seqah	= 77
.equ	lmo_seqbl	= 78
.equ	lmo_seqbh	= 79

