#!/usr/bin/perl
#################################################################################
#										#
# table generator for libmio							#
# copyright (c) 2006-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
#										#
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 2		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################
sub clear_cells
{
    for($i=0;$i<768;$i++)
    {
	$hcell[$i]=0;
    }
}

sub get_pixel
{
    $nb=0;
    if ($z =~ /^\./) {$nb=0}
    elsif ($z =~ /^x/) {$nb=1}
    $z=$';
    return $nb;
}

&clear_cells;

###############################################################################
# read icon cells
###############################################################################
open (RTAB, "itab.dat");
$cline=0;
$count=0;
$oe=0;
$mbyte=0;

while(<RTAB>)
{
    $z=$_;
    chomp($z);
    if ($z =~ /icon/) 
    {
	$cline=0;
    }
    
    elsif (length($z)>7)

    {
	$mbyte=0;
	for ($i=0;$i<8;$i++)
	{
	    $mbyte/=2;
	    $pix=&get_pixel();
	    if ($pix > 0 ) 
	    {
		$mbyte+=128;
	    }	    
	}
	$hcell[$count++]=$mbyte;
    }
}

close(RTAB);
print $count."\n";

###############################################################################
# write chartable
###############################################################################
open (WTAB, "> ../itable1.inc");
    for($i=0;$i<($count-1)/8;$i++)
    {
        print WTAB "        .db "; 
        for($j=0;$j<8;$j++)
        {
	    $cellpos=$i*8+$j;
	    $y=$hcell[$cellpos];
	    if ($y<1) {printf WTAB "0x00"} 
	    else {printf WTAB "%#2.2x",$y};
	    if ($j<7) {print WTAB ","}
	    else {print WTAB "\n"};
	}
    }
close(WTAB);

