#!/usr/bin/perl
#################################################################################
#										#
# table generator for libmio							#
# copyright (c) 2006-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
#										#
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 2		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################
$takt=16000000;
$pwm=256;
$maxcount=65536;
$fakt=3.5;


open ($fh, ">../soundtables.inc");


#---generate offset table for notes--------------------------
$sprung=exp(log(2)/12);
$samfrq=$takt/$pwm;
print $fh "\n\nlibmio_ntable:";

for($j=0;$j<8;$j++)
{
    print $fh "\n    .db ";
    for($i=0;$i<8;$i++)
    {
	$x=$i+8*$j;
	$freq=440*$sprung**($x+3);
	$delta=$maxcount*$freq/$samfrq;
	$y=int($delta+0.5);
	if (($y%256)<1) {printf $fh "0x00,"} else {printf $fh "%#2.2x,",$y%256};
	if (($y/256)<1) {printf $fh "0x00"} else {printf $fh "%#2.2x",$y/256};
	if ($i<7) {print $fh ","};
    }	
}

close($fh);

