;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# user program menu								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
user_menu:	clr	tempreg2		;entry 0
user_menu_re:	ldi	ZL,LOW(user_menudata*2)
		ldi	ZH,HIGH(user_menudata*2)
		libmio_copymenu

user_menu_1:	set
		ldi	r19,5
		libmio_menu5
		cpi	tempreg1,0xed
		brne	user_menu_2
		ret
user_menu_2:	cpi	tempreg1,0xea
		brne	user_menu_1
		
user_menu_3:	cpi	tempreg2,0		;start
		brne	user_menu_4
		rcall	user_start
		rjmp	user_menu
		
user_menu_4:	cpi	tempreg2,1		;load
		brne	user_menu_5
		rcall	user_load
		ldi	tempreg2,1
		rjmp	user_menu_re						

user_menu_5:	cpi	tempreg2,2		;save
		brne	user_menu_6
		rcall	user_save
		ldi	tempreg2,2
		rjmp	user_menu_re

user_menu_6:	cpi	tempreg2,3		;recv
		brne	user_menu_7
		rcall	user_recv
		ldi	tempreg2,3
		rjmp	user_menu_re						

user_menu_7:	rcall	user_send		;send
		ldi	tempreg2,4
		rjmp	user_menu_re
		
;------------------------------------------------------------------------------
;start program
;------------------------------------------------------------------------------
user_start:	clr	tempreg2
user_start_re:  ldi	ZL,LOW(user_starthead*2)
 		ldi	ZH,HIGH(user_starthead*2)
		libmio_menuheadf		;set menuhead
user_start_1:	rcall	user_icons			
		
user_start_3:	clt
		libmio_imenu4
		cpi	tempreg1,0xea
		breq	user_start_8		;select
		cpi	tempreg1,0xed
		brne	user_start_3
		ret

user_start_8:	sts	libmio_lastmenu,tempreg2
		push	tempreg2
		call	mem_progadr		;get prog adr
		adiw	ZL,12			;name offset
		lpm	tempreg1,Z		;get type
		cpi	tempreg1,'N'		;native
		breq	user_start_10		;yes	

		call	tbrun
		ldi	XL,0x00
		libmio_setcolor
		sts	libmio_font,const_0
		libmio_thistext
		.db	54,0,"Press ESC",0
		libmio_nokey
user_start_9:	libmio_waitkey
		cpi	tempreg1,0xed
		brne	user_start_9
		pop	tempreg2
		rjmp	user_start_re		
		
user_start_10:	adiw	ZL,4			;point to start of prg
		icall				;start prog
		pop	tempreg2
		rjmp	user_start_re						

;------------------------------------------------------------------------------
;load program
;------------------------------------------------------------------------------
user_load:	libdfl_size
		cpi	tempreg1,0
		brne	user_load_0
		ret
user_load_0:	clr	tempreg2
user_load_re:  	ldi	ZL,LOW(user_loadhead*2)
 		ldi	ZH,HIGH(user_loadhead*2)
		libmio_menuheadf			;set menuhead
user_load_1:	rcall	user_icons			
		
user_load_3:	clt
		libmio_imenu4
		cpi	tempreg1,0xea
		breq	user_load_8		;select
		cpi	tempreg1,0xed
		brne	user_load_3
		ret

user_load_8:	sts	libmio_lastmenu,tempreg2
		call	fsys_load3k
		lds	tempreg2,libmio_lastmenu
		rjmp	user_load_re		
	
;------------------------------------------------------------------------------
;save program
;------------------------------------------------------------------------------
user_save:	libdfl_size
		cpi	tempreg1,0
		brne	user_save_0
		ret
user_save_0:	clr	tempreg2
user_save_re:  	ldi	ZL,LOW(user_savehead*2)
 		ldi	ZH,HIGH(user_savehead*2)
		libmio_menuheadf			;set menuhead
user_save_1:	rcall	user_icons			
		
user_save_3:	clt
		libmio_imenu4
		cpi	tempreg1,0xea
		breq	user_save_8		;select
		cpi	tempreg1,0xed
		brne	user_save_3
		ret

user_save_8:	sts	libmio_lastmenu,tempreg2
		call	fsys_sav3k
		lds	tempreg2,libmio_lastmenu
		rjmp	user_save_re		
	
;------------------------------------------------------------------------------
;receive program
;------------------------------------------------------------------------------
user_recv:	clr	tempreg2
user_recv_re:  	ldi	ZL,LOW(user_recvhead*2)
 		ldi	ZH,HIGH(user_recvhead*2)
		libmio_menuheadf			;set menuhead
user_recv_1:	rcall	user_icons			
		
user_recv_3:	clt
		libmio_imenu4
		cpi	tempreg1,0xea
		breq	user_recv_8		;select
		cpi	tempreg1,0xed
		brne	user_recv_3
		ret

user_recv_8:	sts	libmio_lastmenu,tempreg2
		rcall	user_recv_txt
		call	recv_prog
		lds	tempreg2,libmio_lastmenu
		rjmp	user_recv_re
	
user_recv_txt:	libmio_mborder
		ldi	ZL,LOW(user_text_1*2)
		ldi	ZH,HIGH(user_text_1*2)
		ldi	XL,7
		ldi	XH,27		
		libmio_xztext
		libmio_nokey
		ret

;------------------------------------------------------------------------------
;send program
;------------------------------------------------------------------------------
user_send:	clr	tempreg2
user_send_re:  	ldi	ZL,LOW(user_sendhead*2)
 		ldi	ZH,HIGH(user_sendhead*2)
		libmio_menuheadf			;set menuhead
user_send_1:	rcall	user_icons			
		
user_send_3:	clt
		libmio_imenu4
		cpi	tempreg1,0xea
		breq	user_send_8		;select
		cpi	tempreg1,0xed
		brne	user_send_3
		ret

user_send_8:	sts	libmio_lastmenu,tempreg2
		rcall	user_send_txt
		call	send_prog
		lds	tempreg2,libmio_lastmenu
		rjmp	user_send_re
	
user_send_txt:	libmio_oborder
		ldi	ZL,LOW(user_text_2*2)
		ldi	ZH,HIGH(user_text_2*2)
		ldi	XL,16
		ldi	XH,27		
		libmio_xztext
		libmio_nokey
		ret	
					
;------------------------------------------------------------------------------
;draw user icon
;------------------------------------------------------------------------------
user_icons:	libmio_menu4icons			;draw 8 empty icons
		ldi	tempreg4,0
		
user_icons_01:	ldi	ZL,LOW(bas_programs*2)
		ldi	ZH,HIGH(bas_programs*2)
		ldi	XL,12
		mul	XL,tempreg4
		add	ZH,r0
		sts	libmio_font,const_1
		ldi	XL,8			;X-pos
		ldi	XH,24			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		libmio_gotoxy				
		ldi	XL,12
user_icons_02:	lpm	tempreg1,Z+
		libmio_outchar
		dec	XL
		brne	user_icons_02

		ldi	XL,24			;X-pos
		ldi	XH,12			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		libmio_gotoxy				

		lpm	tempreg1,Z+		;type
		cpi	tempreg1,'N'		;AVR code
		brne	user_icons_10
		libmio_thistext
		.db	255,"NAT",0,0
		rjmp	user_icons_en				
		
user_icons_10:	cpi	tempreg1,'C'		;chip8 code
		brne	user_icons_11
		libmio_thistext
		.db	255,"CH8",0,0
		rjmp	user_icons_en			

user_icons_11:	libmio_thistext
		.db	255,"BAS",0,0				
	
user_icons_en:	inc	tempreg4
		sbrs	tempreg4,2
		rjmp	user_icons_01
		libmio_nokey			;wait for no key
		ret
										