;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# gps functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
gps_main:	ldi	ZL,LOW(libmio_icons*2+330)
		ldi	ZH,HIGH(libmio_icons*2+330)
		libmio_appframe
		libmio_thistext		
		.db 0,10,"-GPS",0,0
		
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		ldi	XL,64
		ldi	XH,'-'
gps_main_i1:	st	Y+,XH
		dec	XL
		brne	gps_main_i1
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		ldi	XL,0x30
		std	Y+8,const_0
		std	Y+9,const_0
		std	Y+21,const_0
		std	Y+34,const_0		
		std	Y+38,const_0
		std	Y+39,XL
		std	Y+40,XL
		std	Y+41,XL
		std	Y+42,const_0
		std	Y+51,const_0

		
		ldi	XL,0x01			;set normal
		libmio_setcolor

		
		ldi	YL,11			;separator line
		ldi	YH,44
		ldi	ZL,116
		ldi	ZH,44
		libmio_fbox
		
		ldi	YL,89			;box for angle arrow
		ldi	YH,36
		ldi	ZL,117
		ldi	ZH,63
		libmio_fbox	
		libmio_nokey			
				

gps_main_20:	
		sts	libmio_font,const_1
		ldi	XL,12
		ldi	XH,12
		ldi	ZL,LOW(gps_text_1*2)	;text pointer
		ldi	ZH,HIGH(gps_text_1*2)	
		libmio_xztext	
		ldi	XL,12
		ldi	XH,23
		ldi	ZL,LOW(gps_text_2*2)	;text pointer
		ldi	ZH,HIGH(gps_text_2*2)	
		libmio_xztext						
		ldi	XL,12
		ldi	XH,34
		ldi	ZL,LOW(gps_text_3*2)	;text pointer
		ldi	ZH,HIGH(gps_text_3*2)					
		libmio_xztext	

		libmio_thistext		
		.db 46,12,"GRP:",0,0
		rcall	gps_flg			;find last group
		libmio_thistext		
		.db 55,12,"Pt:",0
		rcall	gps_freedata		;get free space
		mov	XL,tempreg5
		clr	XH
		ldi	ctrl,0x06
		libmio_outdez
		libmio_thistext		
		.db 255,"   Fr:",0
		mov	XL,tempreg4
		clr	XH
		ldi	ctrl,0x06
		libmio_outdez
		libmio_thistext		
		.db 255,"/105",0	
				
gps_main_20n:	sts	libmio_font,const_0		
		ldi	XL,0x00	
		libmio_setcolor	
		libmio_nokey
		
gps_main_21:	ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		libgps_rrmc			;get RMC data		
    		ldi	XL,0x00	
		libmio_setcolor
		clr	XH
		ldi	XL,10
		libmio_gotoxy
		lds	XL,bas_array+9
		ldi	tempreg1,'?'
		sbrc	XL,0
		ldi	tempreg1,'*'
		libmio_outchar
		sts	libmio_font,const_1	;small font
				
;output time		
		ldi	XL,40
		ldi	XH,2
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array)
		ldi	ZH,HIGH(bas_array)
		libmio_ramtext
;output date		
		ldi	XL,80
		ldi	XH,2
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array+43)
		ldi	ZH,HIGH(bas_array+43)
		libmio_ramtext

		sts	libmio_font,const_0	;normal font
		ldi	XL,0x01			;set normal
		libmio_setcolor				
		
;output latitude		
		ldi	XL,44
		ldi	XH,11
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array+10)
		ldi	ZH,HIGH(bas_array+10)
		libmio_ramtext

;output longitude		
		ldi	XL,38
		ldi	XH,22
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array+22)
		ldi	ZH,HIGH(bas_array+22)
		libmio_ramtext

;output speed		
		ldi	XL,41
		ldi	XH,33
		libmio_gotoxy						
		ldi	ZL,LOW(bas_array+35)
		ldi	ZH,HIGH(bas_array+35)
		libmio_ramtext
		libmio_thistext
		.db	255,"km/h",0

;output angle arrow	
		ldi	XL,90			;offset X
		ldi	XH,38
		rcall	gps_arrow				
		ldi	XL,102			;offset X
		ldi	XH,50
		
		rcall	gps_cspeed
		brts	gps_main_sv1
		sts	libmio_color,const_1

		sts	libmio_bcsrcx,XL
		sts	libmio_bcsrcy,XH
		ldi	XL,6				;radius
		sts	libmio_bcdx,XL
		sts	libmio_bcdy,XL
		libmio_fcircle				;clear area
		
		
gps_main_sv1:	lds	XL,libmio_keycode
		cpi	XL,0xed			;ESC
		brne	gps_main_22
		ret

gps_main_22:	cpi	XL,0xea			;ENTER
		brne	gps_main_22a
		rcall	gps_fmenu1
		rjmp	gps_main

gps_main_22a:	cpi	XL,0xe4			;up=GRP
		brne	gps_main_23
		rcall	gps_ngroup
		rjmp	gps_main

gps_main_23:	cpi	XL,0xe5			;down=log
		brne	gps_main_24
		rcall	gps_ntag
		rjmp	gps_main
		
gps_main_24:	cpi	XL,0xe2			;left=menu
		brne	gps_main_25
		jmp	gps3_main
		
gps_main_25:	cpi	XL,0xe3			;right=menu
		brne	gps_main_26
		jmp	gps2_main
		
gps_main_26:	rjmp	gps_main_21	

;------------------------------------------------------------------------------
;draw direction arrow X,Y= coords
;------------------------------------------------------------------------------
gps_arrow:	push	XL				;save coords
		push	XH				;+12
		subi	XH,0xf4				;+12	
		subi	XL,0xf4				;+12			
		sts	libmio_bcsrcx,XL
		sts	libmio_bcsrcy,XH
		ldi	XL,13				;radius
		sts	libmio_bcdx,XL
		sts	libmio_bcdy,XL
		ldi	XL,0x00				;inverse
		libmio_setcolor
		libmio_fcircle				;clear area
		ldi	XL,0x01				;normal
		libmio_setcolor
    		lds	tempreg3,(bas_array+39)	;*100
		subi	tempreg3,0x30			;sub num base
		ldi	tempreg2,10
		mul	tempreg3,tempreg2
		lds	tempreg2,(bas_array+40)	;*10
		subi	tempreg2,0x30			;sub num base	
		add	tempreg2,r0
		ldi	ZL,LOW(gps_atab*2)
		ldi	ZH,HIGH(gps_atab*2)
		lsl	tempreg2			;*2
		add	ZL,tempreg2			;table-pos
		adc	ZH,const_0
		pop	XH
		pop	XL		
		lpm	r16,Z+				;pos 1 y
		add	r16,XH
		sts	bas_array+64,r16
		lpm	r16,Z+				;pos 1 x
		add	r16,XL
		sts	bas_array+65,r16
		adiw	ZL,28				;+170deg
		lpm	r16,Z+				;pos 2 y
		add	r16,XH
		sts	bas_array+66,r16
		lpm	r16,Z+				;pos 2 x
		add	r16,XL
		sts	bas_array+67,r16
		adiw	ZL,10				;+10deg
		lpm	r16,Z+				;pos 3 y
		add	r16,XH
		sts	bas_array+68,r16
		lpm	r16,Z+				;pos 3 x
		add	r16,XL
		sts	bas_array+69,r16

		lds	YH,bas_array+64
		lds	YL,bas_array+65
		lds	ZH,bas_array+66
		lds	ZL,bas_array+67
		libmio_draw
		lds	ZH,bas_array+68
		lds	ZL,bas_array+69
		libmio_draw
		lds	YH,bas_array+66
		lds	YL,bas_array+67
		libmio_draw
		ret
		
;------------------------------------------------------------------------------
;ask for new group
;------------------------------------------------------------------------------
gps_ngroup:	rcall	gps_freedata			;space available
		cpi	tempreg4,1
		brcs	gps_ngroup_e			;no
		push	tempreg2
		ldi	tempreg2,12			;number of chars
		ldi	ZL,LOW(gps_ngroupt*2)		;points to text
		ldi	ZH,HIGH(gps_ngroupt*2)		
		libmio_newtext				;alpha keyboard
		pop	tempreg2
		brtc	gps_ngroup_e
		ldi	tempreg1,12
		mul	tempreg1,tempreg2
		movw	YL,r0
		adiw	YL,20				;data offset
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)
		ldi	XL,12
		libeep_put
gps_ngroup_e:	libmio_nokey
		ret
		
;------------------------------------------------------------------------------
;check for speed
;------------------------------------------------------------------------------
gps_cspeed:	set					;valid
		lds	r16,bas_array+35				
		cpi	r16,0x30
		breq	gps_cspeed_1
		ret
gps_cspeed_1:	lds	r16,bas_array+36				
		cpi	r16,0x30
		breq	gps_cspeed_2
		ret
gps_cspeed_2:	lds	r16,bas_array+37				
		cpi	r16,0x33
		brcs	gps_cspeed_3
		ret
gps_cspeed_3:	clt
		ret		
				    	
;------------------------------------------------------------------------------
;count free EE data sets to tempreg4 and number of first free to tempreg2
;tempreg5=data sets in last group
;------------------------------------------------------------------------------
gps_freedata:	ldi	YL,20				;set pointer to start
		ldi	YH,0
		ldi	tempreg3,0			;number of data sets
		mov	tempreg5,const_0		;number of datasets in group
		ldi	tempreg2,0xff			;number of first free
		clr	tempreg4			;counter
gps_freedata_1:	libeep_read				;get signature byte
		cpi	tempreg1,0xff			;empty
		brne	gps_freedata_2			;is not
		inc	tempreg4			;free counter +1
		cpi	tempreg2,0xff
		brne	gps_freedata_4
		mov	tempreg2,tempreg3
		rjmp	gps_freedata_4
gps_freedata_2:	sbrs	tempreg1,7			;skip if no group
		mov	tempreg5,const_0		;clear number of datasets
gps_freedata_3:	sbrc	tempreg1,7			;text
		inc	tempreg5			;inc number of datasets
gps_freedata_4:	
		adiw	YL,11
		inc	tempreg3
		cpi	tempreg3,105
		brne	gps_freedata_1
		ret

;------------------------------------------------------------------------------
;set new data tag
;------------------------------------------------------------------------------
gps_ntag_eex:	ret
gps_ntag:	lds	XL,bas_array+9			;AV flag
		sbrs	XL,0				;skip if valid
		ret
gps_ntag_01:	rcall	gps_freedata			;space available
		cpi	tempreg4,1
		brcs	gps_ntag_eex			;no
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)

		ldi	XL,0x80				;base
		lds	XH,bas_array+20			;N/S
		cpi	XH,'S'
		brne	gps_ntag_02
		ori	XL,0x40
gps_ntag_02:	lds	XH,bas_array+33			;W/E
		cpi	XH,'W'
		brne	gps_ntag_03
		ori	XL,0x20
gps_ntag_03:	lds	XH,bas_array+22			;0/1
		cpi	XH,'1'
		brne	gps_ntag_04
		ori	XL,0x10		
gps_ntag_04:	ldi	YL,LOW(bas_array+46)		;start of month
		ldi	YH,HIGH(bas_array+46)
		ld	XH,Y+				;10 month
		sbrc	XH,1
		subi	XL,0xf6				;+10
		ld	XH,Y+				;1 month
		andi	XH,0x0f
		add	XL,XH
		st	Z+,XL				;store byte 0

		
;store day	
		ldi	YL,LOW(bas_array+43)		;start of date
		ldi	YH,HIGH(bas_array+43)
		rcall	gps_pack2			;day
		st	Z+,XL				;store byte 1

;store time
		ldi	YL,LOW(bas_array)		;start of time
		ldi	YH,HIGH(bas_array)
		rcall	gps_pack2			;hour
		st	Z+,XL				;store byte 2
		adiw	YL,1				;skip separator
		rcall	gps_pack2			;minute
		st	Z+,XL				;store byte 3

;store latitude		
		ldi	YL,LOW(bas_array+10)		;start of time
		ldi	YH,HIGH(bas_array+10)
		rcall	gps_pack2			;deg
		st	Z+,XL				;store byte 4
		adiw	YL,1				;skip separator
		rcall	gps_pack2			;deg/100
		st	Z+,XL				;store byte 5
		rcall	gps_pack2			;deg/10000
		st	Z+,XL				;store byte 6
		rcall	gps_pack2			;deg/1000000
		st	Z+,XL				;store byte 7
;store longitude		
		ldi	YL,LOW(bas_array+23)		;start of time
		ldi	YH,HIGH(bas_array+23)
		rcall	gps_pack2			;deg
		st	Z+,XL				;store byte 8
		adiw	YL,1				;skip separator
		rcall	gps_pack2			;deg/100
		st	Z+,XL				;store byte 9
		rcall	gps_pack2			;deg/10000
		st	Z+,XL				;store byte 10
		rcall	gps_pack2			;deg/1000000
		st	Z+,XL				;store byte 11
;store to EEPROM
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)
		ldi	tempreg1,12
		mul	tempreg1,tempreg2
		movw	YL,r0
		adiw	YL,20
		ldi	XL,12
		libeep_put
gps_ntag_e:	libmio_nokey
		ret			
		
;------------------------------------------------------------------------------
;get Y,Y+ packed to XL
;------------------------------------------------------------------------------
gps_pack2:	ld	XH,Y+
		ld	XL,Y+
		andi	XL,0x0f
		andi	XH,0x0f
		swap	XH
		add	XL,XH
		ret

;------------------------------------------------------------------------------
;unpack and send tempreg1
;------------------------------------------------------------------------------
gps_unpack2:	push	tempreg1
		swap	tempreg1
		andi	tempreg1,0x0f
		ori	tempreg1,0x30
		libmio_pser
		pop	tempreg1
		andi	tempreg1,0x0f
		ori	tempreg1,0x30
		libmio_pser
		ret		

;------------------------------------------------------------------------------
;find last group and write to screen
;------------------------------------------------------------------------------
gps_flg:	ldi	YL,20				;set pointer to start
		ldi	YH,0
		ldi	tempreg2,0xff			;no free
		ldi	tempreg3,0			;number of data sets
gps_flg_1:	libeep_read				;get signature byte
		sbrs	tempreg1,7			;skip if no group
		mov	tempreg2,tempreg3		;copy pointer
gps_flg_2:	adiw	YL,11
		inc	tempreg3
		cpi	tempreg3,105
		brne	gps_flg_1
;now we have a resultr or not (ff)
		cpi	tempreg2,0xff
		brne	gps_flg_4
		ldi	ZL,LOW(gps_nogrpt*2)
		ldi	ZH,HIGH(gps_nogrpt*2)
		ldi	XL,12
gps_flg_3:	lpm	tempreg1,Z+
		libmio_outchar
		dec	XL
		brne	gps_flg_3
		ret
				
gps_flg_4:	ldi	tempreg1,12
		mul	tempreg1,tempreg2				
		movw	YL,r0
		adiw	YL,20
		ldi	XL,12
gps_flg_5:	libeep_read
		libmio_outchar
		dec	XL
		brne	gps_flg_5
		ret

;------------------------------------------------------------------------------
;FILE MENU 1
;------------------------------------------------------------------------------
gps_fmenu1:	clr	tempreg2			;first entry

gps_fmenu1_re:	ldi	ZL,LOW(menudata_glog*2)
		ldi	ZH,HIGH(menudata_glog*2)
		libmio_copymenu
		
gps_fmenu1_1:	set
		ldi	r19,4
		libmio_menu5

gps_fmenu1_3:	cpi	tempreg1,0xed			;ESC
		brne	gps_fmenu1_4
		ret
		
gps_fmenu1_4:	cpi	tempreg1,0xea			;ENTER
		brne	gps_fmenu1_1
		
		cpi	tempreg2,0			;send list
		brne	gps_fmenu1_5
		rcall	gps_send1			;send data
		clr	tempreg2
		rjmp	gps_fmenu1_re			

gps_fmenu1_5:	cpi	tempreg2,1			;delete list
		brne	gps_fmenu1_6
		rcall	gps_adel			;clear data
		ldi	tempreg2,1
		rjmp	gps_fmenu1_re			

gps_fmenu1_6:	cpi	tempreg2,2			;delete list
		brne	gps_fmenu1_7
		ldi	tempreg2,0x10			;masl
		call	fsys_loadgps			;load data
		ldi	tempreg2,2
		rjmp	gps_fmenu1_re			

gps_fmenu1_7:	cpi	tempreg2,3			;delete list
		brne	gps_fmenu1_1
		call	fsys_savegps			;save data
		ldi	tempreg2,3
		rjmp	gps_fmenu1_re			


;------------------------------------------------------------------------------
;delete EEPROM data
;------------------------------------------------------------------------------
gps_adel:	libmio_oborder	
		ldi	XL,16
		ldi	XH,20
		ldi	ZL,LOW(gps_text_4*2)	;text pointer
		ldi	ZH,HIGH(gps_text_4*2)
		libmio_xztext				
		ldi	XL,7
		ldi	XH,32
		ldi	ZL,LOW(text_yn*2)	;text pointer
		ldi	ZH,HIGH(text_yn*2)
		libmio_xztext		

gps_adel_01:	libmio_nokey
		libmio_waitkey
		cpi	tempreg1,0xed		;ESC
		breq	gps_adel_02
		cpi	tempreg1,0xea		;ENT
		brne	gps_adel_01	
		ldi	YL,20				;set pointer to start
		ldi	YH,0
		ldi	tempreg3,105			;number of data sets
gps_cleardat_1:	ldi	tempreg1,0xff			;empty flag
		libeep_write
		adiw	YL,11
		dec	tempreg3
		brne	gps_cleardat_1
		ret

gps_adel_02:	ret


;------------------------------------------------------------------------------
;nextline
;------------------------------------------------------------------------------
gps_snl:	ldi	tempreg1,0x0d
		libmio_pser
		ldi	tempreg1,0x0a
		libmio_pser		
		ret
		
;------------------------------------------------------------------------------
;output serial data
;------------------------------------------------------------------------------
gps_send1:	ldi	ZL,LOW(gps_tpre*2)
		ldi	ZH,HIGH(gps_tpre*2)
		libmio_serftext

		ldi	XL,12				;name len
		ldi	YL,0				;set pointer to name
		ldi	YH,0
gps_send1_01:	libeep_read				;get byte
		libmio_pser				;out
		dec	XL
		brne	gps_send1_01
		adiw	YL,8				;correct pointer	
		rcall	gps_snl				;out newline
		
		ldi	tempreg3,0			;data set
gps_send1_1:	libeep_read				;get byte
		cpi	tempreg1,0xff			;empty
		breq	gps_send1_30			;no output
		
		sbrc	tempreg1,7			;text
		rjmp	gps_send1_10
		ldi	ZL,LOW(gps_txthd*2)
		ldi	ZH,HIGH(gps_txthd*2)
		libmio_serftext
gps_send1_02:	ldi	XL,12				;no of chars
gps_send1_03:	libeep_read
		libmio_pser
		dec	XL
		brne	gps_send1_03
		rcall	gps_snl				;newline
gps_send1_05:	sbiw	YL,12
				
gps_send1_30:	adiw	YL,12				;loop
		inc	tempreg3
		cpi	tempreg3,105
		brne	gps_send1_1
		ldi	ZL,LOW(gps_tpost*2)
		ldi	ZH,HIGH(gps_tpost*2)
		libmio_serftext				
		ret
				
			
gps_send1_10:	ldi	ZL,LOW(gps_dathd*2)
		ldi	ZH,HIGH(gps_dathd*2)
		libmio_serftext
;date
gps_send1_12:	libeep_read			;byte0
		mov	tempreg4,tempreg1
		
		libeep_read			;byte 1 is day
		rcall	gps_unpack2
		ldi	tempreg1,'.'
		libmio_pser
	
		mov	tempreg2,tempreg4
		andi	tempreg2,0x0f
		cpi	tempreg2,0x0a
		brcs	gps_send1_13
		
		ldi	tempreg1,'1'
		libmio_pser
		subi	tempreg2,0x0a
gps_send1_13:	mov	tempreg1,tempreg2
		subi	tempreg1,0xd0
		libmio_pser
		ldi	tempreg1,','
		libmio_pser
		
;time
		libeep_read
		rcall	gps_unpack2
		ldi	tempreg1,':'
		libmio_pser
		libeep_read
		rcall	gps_unpack2
		ldi	tempreg1,','
		libmio_pser
;longitude		
		ldi	tempreg1,'-'
		sbrc	tempreg4,6
		libmio_pser
		libeep_read
		rcall	gps_unpack2
		ldi	tempreg1,'.'
		libmio_pser
		libeep_read
		rcall	gps_unpack2
		libeep_read
		rcall	gps_unpack2
		libeep_read
		rcall	gps_unpack2
		ldi	tempreg1,','
		libmio_pser
;latitude
		ldi	tempreg1,'-'
		sbrc	tempreg4,5
		libmio_pser
		ldi	tempreg1,'1'
		sbrc	tempreg4,4
		libmio_pser
		libeep_read
		rcall	gps_unpack2
		ldi	tempreg1,'.'
		libmio_pser
		libeep_read
		rcall	gps_unpack2
		libeep_read
		rcall	gps_unpack2
		libeep_read
		rcall	gps_unpack2
		rcall	gps_snl			;newline

gps_send1_15:	sbiw	YL,12
		rjmp	gps_send1_30	
	
	
		

						
