;################################################################################
;#										#
;# chipbasic2m - mobile single chip basic computer with ATMega 644		#
;# intro screen									#
;# copyright (c) 2006-8 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;intro screen
;------------------------------------------------------------------------------
intro_main:
		call	timer_stwac		;clear timer
		sts	timer_ram,const_0
		sts	timer_ram+1,const_0
		sts	timer_ram+2,const_0
		sts	timer_ram+3,const_0			
		clr	ctrl			;normal size
		libmio_setnorm
		ldi	YL,2
		ldi	YH,2
		ldi	ZL,125
		ldi	ZH,58
		libmio_box
		sts	libmio_rtc,const_0	;initial value
;check for rtc			
		libi2c_rtc3232_read_status
		cpi	ereg,0
		brne	intro_rtcc_5		;we have no RTC
		sts	libmio_rtc,const_1		
;alarm?				
		sbrs	XL,0			;skip if alarm enabled
		rjmp	intro_eec_2		;no alarm
		sbrs	XH,0			;skip if alarm occured
		rjmp	intro_eec_2		;no alarm
		lds	XL,libmio_sysconf
		ori	XL,0x08			;set audio flag
		sts	libmio_sysconf,XL			
		jmp	timer_alarm
;log		
intro_eec_2:		
		sbrs	XL,1			;skip if log enabled
		rjmp	intro_eec_3		;no log
		sbrs	XH,1			;skip if log occured
		rjmp	intro_eec_3		;no log		

		;code for log activity
		
intro_eec_3:
		
;neither alarm or log is responsible for power on 

				
intro_rtcc_5:	libmio_thistext
		.db	5,14,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0
		libmio_thistext
		.db	28,14,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0		

		ldi	YL,11
		ldi	YH,12
		ldi	ZL,115
		ldi	ZH,30
		libmio_fbox
		
		libmio_setinv			;set color
		libmio_thistext						
		.db	18,18,"AVR-ChipBasic2m",0
								
		libmio_setnorm			;set color
		lds	XL,libmio_rtc
		cpi	ereg,0
		brne	intro_rtct
		libmio_thistext
		.db	35,25,"V0.37-RTC3232",0
		rjmp	intro_rtct1
intro_rtct:	libmio_thistext
		.db	35,31,"V0.37-noRTC",0
intro_rtct1:		
		libmio_thistext
		.db	45,12,"(c)2008 J.Wolfram",0

		libmio_setinv			;set color
		ldi	XL,1
		ldi	XH,55
		ldi	ZL,LOW(text_intro_1*2)	;text key turns
		ldi	ZH,HIGH(text_intro_1*2)		
		libmio_xztext			


intro_main_01:					 
		ldi	tempreg3,150		;wait 3 seconds
intro_main_w:	libmio_sync
		lds	XL,libmio_keycode
		cpi	XL,0x00
		brne	intro_main_f
		dec	tempreg3
		brne	intro_main_w
		jmp	menu_main		
				
intro_main_f:	lds	XL,libmio_sysconf
		ldi	XH,0x10
		eor	XL,XH
		sts	libmio_sysconf,XL
		call	mem_setconf		;write new config to EEPROM
		libmio_nokey
		rjmp	intro_main_01
		
										