;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# measurement functions							#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

meas_menu: 	clr	tempreg2
meas_menu_re:	set
		ldi	ZL,LOW(menu_stab1*2)
		ldi	ZH,HIGH(menu_stab1*2)
		libmio_imenu8
meas_menu_1:	cpi	tempreg1,0xed		;ESC
		brne	meas_menu_2
		ldi	tempreg2,2
		jmp	menu_main_re
		
		cpi	tempreg1,0xea
		brne	meas_menu_re				

meas_menu_2:	cpi	tempreg2,0		;time
		brne	meas_menu_3
		call	time_meas
		clr	tempreg2
		rjmp	meas_menu_re

meas_menu_3:	cpi	tempreg2,1		;temperature
		brne	meas_menu_4
		call	thermo_main
		ldi	tempreg2,1		;		
		rjmp	meas_menu_re		;loop

meas_menu_4:	cpi	tempreg2,2		;logic
		brne	meas_menu_5
		call	minla_main
		ldi	tempreg2,2		;		
		rjmp	meas_menu_re		;loop	

meas_menu_5:	cpi	tempreg2,3		;voltage
		brne	meas_menu_6
		call	volt_main		
		ldi	tempreg2,3		;		
		rjmp	meas_menu_re		;loop			

meas_menu_6:	cpi	tempreg2,4		;curve
		brne	meas_menu_7
		call	mincu_main
		ldi	tempreg2,4		;		
		rjmp	meas_menu_re		;loop	

meas_menu_7:	cpi	tempreg2,5		;
		brne	meas_menu_8
		call	count_main
		ldi	tempreg2,5		;		
		rjmp	meas_menu_re		;loop	

meas_menu_8:	cpi	tempreg2,6		;
		brne	meas_menu_9
		call	snif_main
		ldi	tempreg2,6		;		
		rjmp	meas_menu_re		;loop	
	
meas_menu_9:	
		ldi	tempreg2,7		;		
		rjmp	meas_menu_re		;loop	

