;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# mini logic analyzer								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;main menu
;------------------------------------------------------------------------------	
mincu_main:	ldi	tempreg1,0x02		;typebyte for curve
		sts	rdata_head+25,tempreg1
		ldi	YL,LOW(2030)
		ldi	YH,HIGH(2030)
		libeep_read
		cpi	tempreg1,6
		brcc	mincu_geep_1
		ldi	tempreg1,6
mincu_geep_1:	cpi	tempreg1,14
		brcs	mincu_geep_2
		ldi	tempreg1,13
mincu_geep_2:	sts	rdata_head+20,tempreg1		;sr
			

		ldi	YL,LOW(2031)
		ldi	YH,HIGH(2031)
		libeep_read
		cpi	tempreg1,3
		brcs	mincu_geep_3
		ldi	tempreg1,2
mincu_geep_3:	sts	rdata_head+21,tempreg1		;mode

		ldi	YL,LOW(2032)
		ldi	YH,HIGH(2032)
		libeep_read
		sts	rdata_head+22,tempreg1
		ldi	ZL,LOW(2000)		;1 num of bytes
		ldi	ZH,HIGH(2000)		;1			
		ldi	YL,LOW(rdata_buf)	;set buffer start
		ldi	YH,HIGH(rdata_buf)
mincu_sample0:	st	Y+,const_0		;fill buffer with neutral
		sbiw	ZL,1
		brne	mincu_sample0
		rcall	mincu_adcinit							
		ldi	r16,0xf0		;MUX set (2.56V, 0/1 diff)
		sts	ADMUX,r16
		ldi	r16,0xd6		;start ADC (dummy conversion)
		sts	ADCSRA,r16
mincu_sample01:	lds	r16,ADCSRA
		sbrc	r16,6
		rjmp	mincu_sample01
			
mincu_main_0:	clr	tempreg2		
mincu_main_re:	ldi	ZL,LOW(mincu_dmain*2)
		ldi	ZH,HIGH(mincu_dmain*2)
		libmio_copymenu
		rcall	mincu_dconf
mincu_main_1:	set
		ldi	r19,5
		libmio_menu5
		cpi	tempreg1,0xed
		brne	mincu_main_11
		ret
mincu_main_11:	
		cpi	tempreg2,1		;sample rate
		brne	mincu_main_2
		rcall	mincu_dsr
		ldi	YL,LOW(2030)
		ldi	YH,HIGH(2030)
		libeep_write
		ldi	tempreg2,1
		rjmp	mincu_main_re

mincu_main_2:	cpi	tempreg2,2		;trigger mode
		brne	mincu_main_4
		cpi	tempreg1,0xea		;ENTER
		brne	mincu_main_3
		rcall	mincu_dtm
		ldi	YL,LOW(2031)
		ldi	YH,HIGH(2031)
		libeep_write
		ldi	tempreg2,2		
		rjmp	mincu_main_re

mincu_main_3:	rcall	mincu_dtl		;trigger level
		ldi	YL,LOW(2032)
		ldi	YH,HIGH(2032)
		libeep_write
		ldi	tempreg2,2		
		rjmp	mincu_main_re
		
mincu_main_4:	cpi	tempreg2,0
		brne	mincu_main_5
		cpi	tempreg1,0xea		;start
		brne	mincu_main_1
		cpi	tempreg2,0
		brne	mincu_main_5
		libmio_oborder
		ldi	XL,19
		ldi	XH,27
		ldi	ZL,LOW(mincu_text_1*2)	;text pointer
		ldi	ZH,HIGH(mincu_text_1*2)
		libmio_xztext			
		libmio_sync
		libmio_sync
		rcall	mincu_sample
		rcall	mincu_view		
		ldi	tempreg2,0
		rjmp	mincu_main_re
		
mincu_main_5:	cpi	tempreg2,3		;view
		brne	mincu_main_6
		rcall	mincu_view		
		ldi	tempreg2,3
		rjmp	mincu_main_re
	
mincu_main_6:	rcall	mincu_fmenu
		ldi	tempreg2,4
		rjmp	mincu_main_re

;------------------------------------------------------------------------------
;dec/inc sample rate index
;------------------------------------------------------------------------------	
mincu_dsr:	cpi	tempreg1,0xe2		;left
		brne	mincu_dsr_10
		lds	tempreg1,rdata_head+20	;sr
		inc	tempreg1
mincu_dsr_1:	cpi	tempreg1,14
		brcs	mincu_dsr_2
		ldi	tempreg1,13
mincu_dsr_2:	cpi	tempreg1,6
		brcc	mincu_dsr_3
		ldi	tempreg1,6
mincu_dsr_3:	sts	rdata_head+20,tempreg1
		ret
		
mincu_dsr_10:	lds	tempreg1,rdata_head+20	;sr
		subi	tempreg1,1
		rjmp	mincu_dsr_1
		

;------------------------------------------------------------------------------
;file menu
;------------------------------------------------------------------------------	
mincu_fmenu:	clr	tempreg2		
mincu_fmenu_re:	ldi	ZL,LOW(mincu_dfile*2)
		ldi	ZH,HIGH(mincu_dfile*2)
		libmio_copymenu
mincu_fmenu_1:	set
		ldi	r19,3
		libmio_menu5
		cpi	tempreg1,0xed
		brne	mincu_fmenu_2
		ret
mincu_fmenu_2:	cpi	tempreg1,0xea
		brne	mincu_fmenu_1
		
		cpi	tempreg2,0
		brne	mincu_fmenu_3
		call	fsys_savemd
		ldi	tempreg2,0
		rjmp	mincu_fmenu_re

mincu_fmenu_3:	cpi	tempreg2,1
		brne	mincu_fmenu_4
		call	fsys_loadmd
		ldi	tempreg2,1		
		rjmp	mincu_fmenu_re

mincu_fmenu_4:	cpi	tempreg2,2
		brne	mincu_fmenu_5
		call	send_ram
		ldi	tempreg2,2		
		rjmp	mincu_fmenu_re


mincu_fmenu_5:	cpi	tempreg2,3
		brne	mincu_fmenu_1
		call	recv_ram
		ldi	tempreg2,3		
		rjmp	mincu_fmenu_re


;------------------------------------------------------------------------------
;switch trigger mode
;------------------------------------------------------------------------------	
mincu_dtm:	lds	tempreg1,rdata_head+21	;trig mode
		inc	tempreg1
		cpi	tempreg1,0x03
		brne	mincu_dtm_1
		ldi	tempreg1,0
mincu_dtm_1:	sts	rdata_head+21,tempreg1
		ret

;------------------------------------------------------------------------------
;dec/inc trigger level
;------------------------------------------------------------------------------	
mincu_dtl:	cpi	tempreg1,0xe2		;left
		brne	mincu_dtl_10

		lds	tempreg1,rdata_head+22	;trig level
		subi	tempreg1,4
mincu_dtl_1:	andi	tempreg1,0xfc
		sts	rdata_head+22,tempreg1
		ret
	
mincu_dtl_10:	lds	tempreg1,rdata_head+22	;trig
		subi	tempreg1,0xfc
		rjmp	mincu_dtl_1

;------------------------------------------------------------------------------
;copy conf data into menu
;------------------------------------------------------------------------------	
mincu_dconf:	push	tempreg2
		ldi	ZL,LOW(mincu_cdata_s*2)
		ldi	ZH,HIGH(mincu_cdata_s*2)
		ldi	XL,6			;bytes per entry
		lds	tempreg1,rdata_head+20	;sr
		subi	tempreg1,6
		mul	XL,tempreg1		;* srate
		add	ZL,r0
		adc	ZH,r1
		ldi	YL,LOW(libmio_mram+50)
		ldi	YH,HIGH(libmio_mram+50)
		ldi	XL,6
mincu_dconf_1:	lpm	XH,Z+
		st	Y+,XH
		dec	XL
		brne	mincu_dconf_1
	
		ldi	ZL,LOW(mincu_cdata_m*2)
		ldi	ZH,HIGH(mincu_cdata_m*2)		

		lds	tempreg1,rdata_head+21	;tmode
		add	ZL,tempreg1
		adc	ZH,const_0
		ldi	YL,LOW(libmio_mram+66)
		ldi	YH,HIGH(libmio_mram+66)
mincu_dconf_2:	lpm	XH,Z+
		st	Y+,XH
		ldi	XL,3
		sts	libmio_channel,XL	;array
		
		sts	bas_partab,const_0
		sts	bas_partab+1,const_0
		
		ldi	XH,0
		lds	XL,rdata_head+22
		sbrc	XL,7
		ldi	XH,0xff
		ldi	r16,5
		ldi	r17,0
		call	expar_mul
		ldi	ctrl,0x27		;2 lead zero
		libmio_outdez
		ldi	tempreg1,'V'
		libmio_outchar
		sts	libmio_channel,const_0	;restore to screen
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		ldi	XL,LOW(libmio_mram+68)
		ldi	XH,HIGH(libmio_mram+68)
		ldi	ZH,5
mincu_dconf_3:	ld	ZL,Y+
		st	X+,ZL
		dec	ZH
		brne	mincu_dconf_3						
		pop	tempreg2
		ret

		
;------------------------------------------------------------------------------
;read sample (970 clocks)
;------------------------------------------------------------------------------			
mincu_getadc:	ldi	r16,0xd6		;5 (4+1) start ADC 
		sts	ADCSRA,r16		;2		
		ldi	r17,237			;1
mincu_getadc_1:	nop				;237
		dec	r17			;237
		brne	mincu_getadc_1		;473		
		lds	r16,ADCH		;2 get value to r16
		subi	r16,0x80		;1 shift value
		add	XL,r16			;1 add value
		adc	XH,const_0		;1
		inc	tempreg2		;1 subsample counter
		nop				;1
		nop				;1
		ret				;5
				
;------------------------------------------------------------------------------
;do sampling
;tempreg3	tr1		fsample		tmess
;	6	  1		   20k	      355.20 ms
;	7	  2		   10k	      710.40 ms
;	8	  4		    5k	        1.42 s
;	9	 10		    2k	        3.55 s
;      10	 20		    1k	 	7.10 s
;      11	 40		   500	       14.20 s
;      12	100		   200	       35.52 s
;      13	200		   100	       71.04 s
;
;------------------------------------------------------------------------------
mincu_sample:	cli				;disable interrupts			
		ldi	YL,LOW(rdata_buf)	;set buffer start
		ldi	YH,HIGH(rdata_buf)	
		ldi	ZL,LOW(mincu_srd*2)	;sample rate data
		ldi	ZH,HIGH(mincu_srd*2)	;sample rate data			
		lds	tempreg1,rdata_head+20	;sample rate sel
		subi	tempreg1,6		;offset
		lsl	tempreg1		;*4
		lsl	tempreg1
		add	ZL,tempreg1
		adc	ZH,const_0
		lpm	tempreg6,Z+		;number of subsamples
		lpm	tempreg7,Z+		;LOW factor
		lpm	tempreg8,Z+		;HIGH factor
		ldi	tempreg2,0		;init counter
		ldi	ZL,LOW(2000)		;1 num of words
		ldi	ZH,HIGH(2000)		;1			
		lds	r16,UCSR0B
		andi	r16,0xf7		;clear TXEN bit
		sts	UCSR0B,r16							
		sbi	PORTD,1			;2 set trig LED off
		clr	XL			;value sum
		clr	XH				
			
		lds	r18,rdata_head+22	;trigger level	
		subi	r18,0x80		;shift
		lds	tempreg4,rdata_head+21	;trigger mode				
		cpi	tempreg4,0		
		breq	mincu_trise

		cpi	tempreg4,1		
		breq	mincu_tfall

		rjmp	mincu_read												
	    
mincu_esc:	clt				;clear T-flag
mincu_end:	lds	r16,UCSR0B
		ori	r16,0x08		;set TXEN bit
		sts	UCSR0B,r16
		sei				;re-enable interrupts											
		ret

								
;------------------------------------------------------------------------------
;all sample modes
;------------------------------------------------------------------------------					
mincu_trise:	rcall	mincu_getadc
		sbis	PIND,3			;ESC
		rjmp	mincu_esc
		cp	r16,r18
		brcc	mincu_trise
		
mincu_trise1:	clr	XL
		clr	XH
		clr	tempreg2
		rcall	mincu_getadc
		sbis	PIND,3			;ESC
		rjmp	mincu_esc
		cp	r16,r18
		brcs	mincu_trise1
		rjmp	mincu_read

mincu_tfall:	rcall	mincu_getadc
		sbis	PIND,3			;ESC
		rjmp	mincu_esc		
		cp	r16,r18
		brcs	mincu_tfall
		
mincu_tfall1:	clr	XL
		clr	XH
		clr	tempreg2
		rcall	mincu_getadc
		sbis	PIND,3			;ESC
		rjmp	mincu_esc		
		cp	r16,r18
		brcc	mincu_tfall1
		rjmp	mincu_read


;now sample data							
mincu_read:	out	PORTD,const_0		;1 LED on
		rjmp	mincu_read_1a		;skip next adc cycle
		
mincu_read_1:	rcall	mincu_getadc		;970
mincu_read_1a:	cp	tempreg6,tempreg2	;1 all subsamples done?
		brne	mincu_read_2		;1/2 no
	
		mul	XL,tempreg7		;2 LOW*LOW
		movw	r18,r0			;2 copy
		ldi	r20,0			;1
		mul	XH,tempreg7		;2 HI*LO
		add	r19,r0			;1
		adc	r20,r1			;1
		mul	XL,tempreg8		;2 LO*HI
		add	r19,r0			;1
		adc	r20,r1			;1
		mul	XH,tempreg8		;2 Hi*Hi
		add	r20,r0			;1		
		lsl	r19			;1
		rol	r20			;1
		subi	r20,0x80		;1 shift		
		st	Y+,r20			;2
		ldi	XL,0			;1
		ldi	XH,0			;1
		ldi	tempreg2,0		;1
		sbiw	ZL,1			;2
		brne	mincu_read_1		;2
		set				;done flag
		rjmp	mincu_end		;end
;+3
mincu_read_2:	ldi	r18,8			;1
mincu_read_3:	dec	r18			;7
		brne	mincu_read_3		;13		
		rjmp	mincu_read_1		;2

;------------------------------------------------------------------------------
;view results
;------------------------------------------------------------------------------			
mincu_view:	ldi	YL,LOW(rdata_ram)
		ldi	YH,HIGH(rdata_ram)
		ldi	XL,7
mincu_view_0:	st	Y+,const_0
		dec	XL
		brne	mincu_view_0
		sts	rdata_ram+9,const_0
		sts	rdata_ram+10,const_0
				
				
		ldi	ZL,LOW(libmio_icons*2+10)
		ldi	ZH,HIGH(libmio_icons*2+10)
		libmio_appframe			;draw appframe
		
		ldi	XL,1
		libmio_setcolor			;set to normal

		ldi	YL,9
		ldi	YH,41
		ldi	ZL,118
		ldi	ZH,42		
		libmio_fbox			;separator 1
		
		ldi	YL,9
		ldi	YH,10
		ldi	ZL,15
		ldi	ZH,40		
		libmio_fbox			;box for markers
					
		ldi	XL,0			;inverse
		libmio_setcolor
		
		ldi	YL,11
		ldi	YH,24
		ldi	ZL,14
		ldi	ZH,24		
		libmio_fbox			;center


		ldi	YL,12
		ldi	YH,9
		ldi	ZL,14
		ldi	ZH,9		
		libmio_fbox			;+M

		ldi	YL,12
		ldi	YH,39
		ldi	ZL,14
		ldi	ZH,39		
		libmio_fbox			;+M

		
		libmio_thistext
		.db	43,10,"TC:",0
		libmio_thistext
		.db	43,64,"dT:",0		
		libmio_thistext
		.db	53,10,"TM:",0
		libmio_thistext
		.db	53,64,"Fr:",0
		ldi	XL,1			;normal
		libmio_setcolor

mincu_view_l:	libmio_nokey	
mincu_view_1:	rcall	mincu_show
mincu_view_re:	rcall	minla_wp		;show window pos
		rcall	mincu_scur1		;show cursor		
		rcall	minla_sval		;show time values
		rcall	mincu_scv

mincu_view_2:	call	libmio_nokeys
		call	libmio_waitkey
		cpi	tempreg1,0xed		;end
		brne	mincu_view_3		
		ret		

mincu_view_3:	cpi	tempreg1,0xe2		;left
		brne	mincu_view_4
		rcall	mincu_scur0		;hide cursor			
		clr	tempreg1
		rcall	minla_movc
		rjmp	mincu_view_1


mincu_view_4:	cpi	tempreg1,0xe3		;right
		brne	mincu_view_5
		rcall	mincu_scur0		;hide cursor			
		ldi	tempreg1,1
		rcall	minla_movc
		rjmp	mincu_view_1
				
mincu_view_5:	cpi	tempreg1,0xe4		;up
		brne	mincu_view_6		
		ldi	tempreg1,2		;window -
		rcall	minla_movc
		rjmp	mincu_view_1


mincu_view_6:	cpi	tempreg1,0xe5		;down
		brne	mincu_view_7
		ldi	tempreg1,3		;window +
		rcall	minla_movc
		rjmp	mincu_view_1

mincu_view_7:	cpi	tempreg1,0xea		;enter
		brne	mincu_view_2
		lds	YL,rdata_ram+2		;cursor pos
		lds	YH,rdata_ram+3		
		sts	rdata_ram+9,YL
		sts	rdata_ram+10,YH
		rjmp	mincu_view_1
		
;------------------------------------------------------------------------------
;show cursor value
;------------------------------------------------------------------------------			
mincu_scv:	ldi	XL,16
		ldi	XH,1
		libmio_gotoxy
		lds	XL,rdata_ram+2		;cursor pos
		lds	XH,rdata_ram+3
		ldi	YL,LOW(rdata_buf)	;set buffer start
		ldi	YH,HIGH(rdata_buf)	
		add	YL,XL
		adc	YH,XH
		ldi	XH,0
		ld	XL,Y
		sbrc	XL,7
		ldi	XH,0xff
		ldi	r16,5
		ldi	r17,0
		call	expar_mul
		sts	libmio_color,const_0
		sts	libmio_font,const_1
		ldi	ctrl,0x27		;2 lead zero
		libmio_outdez
		ldi	tempreg1,'V'
		libmio_outchar
		sts	libmio_color,const_1
		ret
		
;------------------------------------------------------------------------------
;view cursor
;------------------------------------------------------------------------------			
mincu_scur0:	sts	libmio_color,const_0
		rjmp	mincu_scur

mincu_scur1:	sts	libmio_color,const_1
mincu_scur:	lds	YL,rdata_ram+6		;cursor pos
		lsl	YL
		subi	YL,0xef		
		mov	ZL,YL
		ldi	YH,9
		ldi	ZH,41
		libmio_fbox	
		ret
								
;-----------------------------------------------------------------------------
; show wave frame 
; rdata_ram+0	low windowposition
; rdata_ram+1	high windowposition
; rdata_ram+4	low markposition
; rdata_ram+5	high markposition
;-----------------------------------------------------------------------------			
mincu_show:	ldi	YL,LOW(libmio_vram+130)
		ldi	YH,HIGH(libmio_vram+130)
		ldi	XH,34			;lines
mincu_show_1:	ldi	XL,12
mincu_show_2:	st	Y+,const_0		;clear byte
		dec	XL
		brne	mincu_show_2
		ld	tempreg1,Y
		andi	tempreg1,0xe0		;last byte
		st	Y+,tempreg1
		adiw	YL,3
		dec	XH
		brne	mincu_show_1		;loop
		sts	libmio_color,const_1

;draw curve 	
		lds	XL,rdata_ram+0		;win position
		lds	XH,rdata_ram+1		
		ldi	ZL,LOW(rdata_buf)	;buffer
		ldi	ZH,HIGH(rdata_buf)
		add	ZL,XL			;add offset
		adc	ZH,XH
		ld	tempreg5,Z		;get data
		ldi	XL,15			;first pos	
mincu_show_10:	ld	tempreg4,Z+		;get value


;show level
mincu_slev1:	movw	r14,ZL
		mov	XH,tempreg5		;last
		subi	XH,0x80
		lsr	XH
		lsr	XH
		lsr	XH
		ldi	YH,40
		sub	YH,XH
		mov	XH,tempreg4		;new
		subi	XH,0x80
		lsr	XH
		lsr	XH
		lsr	XH
		ldi	ZH,40
		sub	ZH,XH
		mov	YL,XL
		inc	XL
		mov	ZL,XL
		libmio_draw
		movw	ZL,r14
		mov	tempreg5,tempreg4	;set this as old
		inc	XL
		cpi	XL,116			;end
		brcs	mincu_show_10
		ldi	YL,LOW(libmio_vram+16*24+2)
		ldi	YH,HIGH(libmio_vram+16*24+2)
		rcall	mincu_uline
		ret		
			
mincu_adcinit:	ldi	r16,0xf0		;MUX set (2.56V, 0/1 diff)
		sts	ADMUX,r16
		ldi	r16,0xd6		;start ADC (dummy conversion)
		sts	ADCSRA,r16
mincu_adcinit1:	lds	r16,ADCSRA
		sbrc	r16,6
		rjmp	mincu_adcinit1
		ret

mincu_uline:	ldi	XH,12
mincu_uline1:	ld	XL,Y
		ori	XL,0xaa
		st	Y+,XL
		dec	XH
		brne	mincu_uline1
		ld	XL,Y
		ori	XL,0x2a
		st	Y+,XL	
		ret	

;------------------------------------------------------------------------------
;samplerate-data
;------------------------------------------------------------------------------
mincu_srd:	.db	  1,0x00,0x80,0
		.db	  2,0x00,0x40,0
		.db	  4,0x00,0x20,0
		.db	 10,0xcd,0x0c,0
		.db	 20,0x66,0x06,0
		.db	 40,0x33,0x03,0
		.db	100,0x48,0x01,0
		.db	200,0xa4,0x00,0
		
		
mincu_cdata_s:	.db " 20k/s"
		.db " 10k/s"
		.db "  5k/s"
		.db "  2k/s"
		.db "  1k/s"
		.db " 500/s"
		.db " 200/s"
		.db " 100/s"
		
;val 8		
mincu_cdata_m:	.db 0xc0,0xc1,"-",0


