;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# time functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;time meas
;------------------------------------------------------------------------------
time_meas:	sts	time_ram+4,const_0		;mode 0
		sts	time_ram+5,const_0		;inactive
		call	timer_stwac			;reset time
		
time_meas_0:	ldi	ZL,LOW(libmio_icons*2+90)
		ldi	ZH,HIGH(libmio_icons*2+90)
		libmio_appframe
		ldi	XL,25
		ldi	XH,0
		ldi	ZL,LOW(time_text_1*2)	;text pointer
		ldi	ZH,HIGH(time_text_1*2)
		libmio_xztext					
	
		
time_meas_2:	libmio_setnorm
		sts	libmio_font,const_1	;small
		ldi	XL,12
		ldi	XH,11
		ldi	ZL,LOW(time_text_2*2)	;text pointer
		ldi	ZH,HIGH(time_text_2*2)
		libmio_xztext		
		ldi	XL,12
		ldi	XH,29
		ldi	ZL,LOW(time_text_3*2)	;text pointer
		ldi	ZH,HIGH(time_text_3*2)
		libmio_xztext		
		ldi	XL,12
		ldi	XH,47
		ldi	ZL,LOW(time_text_4*2)	;text pointer
		ldi	ZH,HIGH(time_text_4*2)
		libmio_xztext						

		ldi	YL,9
		ldi	YH,27
		ldi	ZL,118
		ldi	ZH,45
		libmio_box
		
		sts	libmio_font,const_0	;normal		
		ldi	XL,47
		ldi	XH,15		
		libmio_gotoxy	
		ldi	ZL,LOW(time_mtext*2)
		ldi	ZH,HIGH(time_mtext*2)	
		ldi	XL,10
		lds	XH,time_ram+4		;mode
		mul	XL,XH
		add	ZL,r0
		adc	ZH,r1
		libmio_romtext			;write mode
;write time		
		ldi	ctrl,0x09
		libmio_thistext
		.db	50,47,0,0
		lds	XL,libmio_tsl
		lds	XH,libmio_tsh
		libmio_outdez
		libmio_outcomma
		ldi	ctrl,0x06
		lds	XL,libmio_tmsl
		lds	XH,libmio_tmsh
		libmio_outdez
		ldi	tempreg1,'s'
		libmio_outchar		

		ldi	XL,53
		ldi	XH,33		
		libmio_gotoxy	
		ldi	ZL,LOW(time_stext1*2)
		ldi	ZH,HIGH(time_stext1*2)			
		libmio_romtext			;write status (idle)				
		
time_meas_3:	libmio_nokey

time_meas_5:	libmio_waitkey			;wait for key
		cpi	tempreg1,0xed		;ESC
		brne	time_meas_6
		ret
		
time_meas_6:	cpi	tempreg1,0xe4		;mode +1
		brne	time_meas_7
		lds	XH,time_ram+4		;mode
		inc	XH
		andi	XH,0x03
		sts	time_ram+4,XH		;store back
		rjmp	time_meas_2		;loop	
				
time_meas_7:	cpi	tempreg1,0xe2		;init
		breq	time_meas_8
		cpi	tempreg1,0xe3
		brne	time_meas_9
time_meas_8:	lds	XL,libmio_tsl
		lds	XH,libmio_tsh								
		lds	YL,libmio_tmsl
		lds	YH,libmio_tmsh
		sts	time_ram,XL
		sts	time_ram+1,XH
		sts	time_ram+2,YL
		sts	time_ram+3,YH		
		call	timer_stwas0
		rjmp	time_meas_0
		
time_meas_9:	cpi	tempreg1,0xea		;init
		brne	time_meas_5				
		ldi	XL,53
		ldi	XH,33		
		libmio_gotoxy	
		ldi	ZL,LOW(time_stext2*2)
		ldi	ZH,HIGH(time_stext2*2)			
		libmio_romtext			;write status (wait)
		call	timer_stwac		;reset time		
				
time_meas_10:	lds	tempreg1,time_ram+4	;read mode
		lds	tempreg3,libmio_keycode
		cpi	tempreg3,0xe5		;down
		breq	time_meas_es
		in	tempreg2,PINA		;read date
		sbrc	tempreg1,0		;skip if rising
		com	tempreg2		;invert
		sbrc	tempreg2,0		;skip if inactive
		rjmp	time_meas_10		;wait for inactive
		
time_meas_11:	in	tempreg2,PINA		;read date
		lds	tempreg3,libmio_keycode
		cpi	tempreg3,0xe5		;down
		breq	time_meas_es
		sbrc	tempreg1,0		;skip if rising
		com	tempreg2		;invert
		sbrs	tempreg2,0		;skip if active
		rjmp	time_meas_11		;wait for active		
		
time_meas_12:	ldi	tempreg1,2
		sts	libmio_tstat,tempreg1	;start
		ldi	XL,53
		ldi	XH,33		
		libmio_gotoxy	
		ldi	ZL,LOW(time_stext3*2)
		ldi	ZH,HIGH(time_stext3*2)			
		libmio_romtext			;write status (meas)	
		rjmp	time_meas_13		;go on
		
time_meas_es:	sts	libmio_tstat,const_0	;stop time
		ldi	XL,53
		ldi	XH,33		
		libmio_gotoxy	
		ldi	ZL,LOW(time_stext4*2)
		ldi	ZH,HIGH(time_stext4*2)			
		libmio_romtext			;write status (canc)		
		rjmp	time_meas_3		;go on
		
time_meas_13:	lds	tempreg3,libmio_keycode
		cpi	tempreg3,0xe5		;stop
		breq	time_meas_es
		
		lds	tempreg1,time_ram+4	;read mode
		in	tempreg2,PINA		;read date
		cpi	tempreg1,2
		brcc	time_meas_14
		
		sbrc	tempreg1,0		;skip if rising
		com	tempreg2		;invert
		sbrc	tempreg2,0		;skip if active
		rjmp	time_meas_13		;wait for inactive
		sts	libmio_tstat,const_0	;stop time				
		rjmp	time_meas_0
		
time_meas_14:	sbrc	tempreg1,0		;skip if rising
		com	tempreg2		;invert
		sbrs	tempreg2,1		;skip if active
		rjmp	time_meas_13		;wait for inactive
		sts	libmio_tstat,const_0	;stop time				
		rjmp	time_meas_0	

