;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# menu functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################
;------------------------------------------------------------------------------
;main screen mask
;------------------------------------------------------------------------------
menu_main:	clr	tempreg2
menu_main_re:	set
		ldi	ZL,LOW(menudata_main*2)
		ldi	ZH,HIGH(menudata_main*2)
		lds	XL,libmio_rtc
		ori	XL,0x02
		sts	libmio_rtc,XL
		libmio_imenu8
		lds	XL,libmio_rtc
		andi	XL,0xfd
		sts	libmio_rtc,XL

		cpi	tempreg1,0xea		;enter
		brne	menu_main_re

menu_main_s:	cpi	tempreg2,0x00		;run
		brne	menu_main_s1
		call	user_menu		;run prog menu
		ldi	tempreg2,0x00
		rjmp	menu_main_re
		
menu_main_s1:	cpi	tempreg2,0x01		;time
		brne	menu_main_s2
		call	timer_menu		;run timer menu
		ldi	tempreg2,0x01
		rjmp	menu_main_re
		
		
menu_main_s2:	cpi	tempreg2,0x02		;meas
		brne	menu_main_s3
		call	meas_menu		;run meas menu
		ldi	tempreg2,0x02
		rjmp	menu_main_re		

menu_main_s3:	cpi	tempreg2,0x03		;gps
		brne	menu_main_s4
		call	gps_main		;run gps
		ldi	tempreg2,0x03
		rjmp	menu_main_re		
				
menu_main_s4:	cpi	tempreg2,0x04		;games
		brne	menu_main_s5
		call	game_menu
		ldi	tempreg2,0x04
		rjmp	menu_main_re		

menu_main_s5:	cpi	tempreg2,0x05		;
		brne	menu_main_s6
		ldi	tempreg2,0x05
		rjmp	menu_main_re
		
menu_main_s6:	cpi	tempreg2,0x06		;file
		brne	menu_main_s7
		call	file_menu		;run file menu
		ldi	tempreg2,0x06
		rjmp	menu_main_re		

menu_main_s7:	call	conf_menu		;configure menu
		ldi	tempreg2,0x07
		rjmp	menu_main_re

