;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# alarm functions								#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################


;------------------------------------------------------------------------------
;alarm menu
;------------------------------------------------------------------------------
timer_mal:	ldi	ZL,LOW(libmio_icons*2+210)
		ldi	ZH,HIGH(libmio_icons*2+210)
		libmio_appframe
		ldi	XL,46
		ldi	XH,0
		ldi	ZL,LOW(timer_text_3*2)	;text pointer
		ldi	ZH,HIGH(timer_text_3*2)
		libmio_xztext				
		
			
timer_mal_2:	libmio_setnorm
		ldi	XL,40
		ldi	XH,22
		ldi	ZL,LOW(timer_text_4*2)	;text pointer
		ldi	ZH,HIGH(timer_text_4*2)
		libmio_xztext					
		
		libmio_thistext
		.db 33,48,0,0
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		libi2c_rtc3232_read_alarm
		ldi	ZL,LOW(bas_array)
		ldi	ZH,HIGH(bas_array)
		libmio_ramtext			;output time
		libmio_thistext
		.db 44,60,0,0
		libi2c_rtc3232_read_status
		ldi	tempreg1,0x87		;bell
		sbrs	XL,0
		ldi	tempreg1,'-'		;no bell
		libmio_outchar
		libmio_nokey
		
timer_mal_3:	lds	tempreg1,libmio_keycode			
		cpi	tempreg1,0xed		;esc
		brne	timer_mal_4
		ldi	tempreg2,2
		jmp	timer_menu_re

timer_mal_4:	cpi	tempreg1,0xe4		;set
		brne	timer_mal_5
		ori	XL,5			;enable
		andi	XH,0xfe			;clear pending flag
timer_mal_4a:	libi2c_rtc3232_write_status
		libmio_sync
		libmio_sync			
		rjmp	timer_mal_2
		
timer_mal_5:	cpi	tempreg1,0xe5		;clr
		brne	timer_mal_6
		andi	XL,0xfe			;disable
		andi	XH,0xfe			;clear pending falg
		rjmp	timer_mal_4a
		
timer_mal_6:	cpi	tempreg1,0xe2		;set new time
		breq	timer_mal_6a
		cpi	tempreg1,0xe3
		brne	timer_mal_3

timer_mal_6a:	ldi	ZL,LOW(timer_satext*2)
		ldi	ZH,HIGH(timer_satext*2)
		ldi	tempreg2,4
		libmio_newnum	
		brtc	timer_mal_7
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		libi2c_rtc3232_write_alarm
		libmio_sync
		libmio_sync
timer_mal_7:	rjmp	timer_mal		
		

;------------------------------------------------------------------------------
;show timer alarm
;------------------------------------------------------------------------------
timer_alarm:	libmio_oborder
		ldi	ctrl,0x40
		libmio_thistext
		.db	10,15,"ALARM!!!",0,0
timer_alarm_1:	ldi	XL,28 
	    	libmio_note
		libmio_nokey			;wait for key release
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		libi2c_rtc3232_read_time
		libmio_thistext		
		.db 40,10,0,0
		ldi	ctrl,0x40
		ldi	ZL,LOW(bas_array)
		ldi	ZH,HIGH(bas_array)
		libmio_ramtext			;output time
		ldi	tempreg2,20
timer_alarm_2:	lds	tempreg1,libmio_keycode
		cpi	tempreg1,0x00
		brne	timer_alarm_10		;
		dec	tempreg2
		brne	timer_alarm_2
		rjmp	timer_alarm_1
timer_alarm_10:	libi2c_rtc3232_read_status
		andi	XL,0xfe			;clear status flag
		andi	XH,0xfe			;clear enable flag
		libmio_sync
		libmio_sync
		libi2c_rtc3232_write_status
timer_alarm_11:	rjmp	timer_alarm_11				
	

