;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# RTC set									#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;time set menu
;------------------------------------------------------------------------------
timer_menus:	clr	tempreg2
timer_menus_re:	sts	libmio_font,const_0
		ldi	ZL,LOW(menudata_times*2)
		ldi	ZH,HIGH(menudata_times*2)
		libmio_copymenu
timer_menus_1:	set
		ldi	r19,4			;4 entries
		libmio_menu5
		cpi	tempreg1,0xed		;ESC
		brne	timer_menus_2
		ldi	tempreg2,1
		jmp	timer_menu_re
		cpi	tempreg1,0xea
		brne	timer_menus_1				

timer_menus_2:	cpi	tempreg2,0		;Uhrzeit
		brne	timer_menus_3
		rjmp	timer_sett

timer_menus_3:	cpi	tempreg2,1		;Datum
		brne	timer_menus_4
		rjmp	timer_setd		

timer_menus_4:	cpi	tempreg2,2		;nach GPS
		brne	timer_menus_5
		rjmp	timer_setg

timer_menus_5:	cpi	tempreg2,3		;Stunde+-
		brne	timer_menus_1
		rjmp	timer_setz

;------------------------------------------------------------------------------
;set time
;------------------------------------------------------------------------------
timer_sett:	ldi	ZL,LOW(timer_sttext*2)
		ldi	ZH,HIGH(timer_sttext*2)
		ldi	tempreg2,6
		libmio_newnum
		ldi	tempreg2,0
		brtc	timer_menus_re
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		libi2c_rtc3232_write_time
		ldi	tempreg2,0
		rjmp	timer_menus_re

;------------------------------------------------------------------------------
;set date
;------------------------------------------------------------------------------
timer_setd:	ldi	ZL,LOW(timer_sdtext*2)
		ldi	ZH,HIGH(timer_sdtext*2)
		ldi	tempreg2,6
		libmio_newnum
		ldi	tempreg2,1
		brtc	timer_menus_re
		ldi	YL,LOW(libmio_tram)
		ldi	YH,HIGH(libmio_tram)
		libi2c_rtc3232_write_date
		ldi	tempreg2,1
		rjmp	timer_menus_re

;------------------------------------------------------------------------------
;set from GPS
;------------------------------------------------------------------------------
timer_setg:	libmio_oborder
		ldi	XL,16
		ldi	XH,27
		ldi	ZL,LOW(timer_text_1*2)	;text pointer
		ldi	ZH,HIGH(timer_text_1*2)
		libmio_xztext					
		
timer_setg_1:	ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		libgps_rrmc		
		lds	tempreg1,libmio_keycode
		cpi	tempreg1,0xed		;ESC
		brne	timer_setg_2
		ldi	tempreg2,2
		rjmp	timer_menus_re
		

timer_setg_2:	lds	XL,bas_array+9
		sbrs	XL,0
		rjmp	timer_setg_1		;not valid
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		rcall	timer_setg_re
		libi2c_rtc3232_write_time
		libmio_sync
		libmio_sync
		ldi	YL,LOW(bas_array+43)
		ldi	YH,HIGH(bas_array+43)
		rcall	timer_setg_re
		libi2c_rtc3232_write_date
		libmio_sync
		libmio_sync
		ldi	tempreg2,2
		rjmp	timer_menus_re

timer_setg_re:	ldd	tempreg1,Y+3
		std	Y+2,tempreg1
		ldd	tempreg1,Y+4
		std	Y+3,tempreg1
		ldd	tempreg1,Y+6
		std	Y+4,tempreg1
		ldd	tempreg1,Y+7
		std	Y+5,tempreg1
		ret

;------------------------------------------------------------------------------
;set timezone
;------------------------------------------------------------------------------
timer_setz:	ldi	ZL,LOW(libmio_icons*2+250)
		ldi	ZH,HIGH(libmio_icons*2+250)
		libmio_appframe
		ldi	XL,16
		ldi	XH,0
		ldi	ZL,LOW(timer_text_2*2)	;text pointer
		ldi	ZH,HIGH(timer_text_3*2)
		libmio_xztext					

		libmio_nokey		;wait for key release		

timer_adj_2:	ldi	XL,1
		libmio_setcolor
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		libi2c_rtc3232_read_time
		libmio_thistext		
		.db 20,14,0,0
		ldi	ctrl,0x40
		ldi	ZL,LOW(bas_array)
		ldi	ZH,HIGH(bas_array)
		libmio_ramtext			;output time
timer_adj_ky:	ldi	tempreg2,8
timer_adj_ky1:	libmio_sync
		lds	tempreg1,libmio_keycode
		cpi	tempreg1,0x00
		brne	timer_adj_kye
		dec	tempreg2
		brne	timer_adj_ky1
		rjmp	timer_adj_2
timer_adj_kye:				
		lds	tempreg1,libmio_keycode
		cpi	tempreg1,0xed		;ESC
		breq	timer_adj_end
		cpi	tempreg1,0xe4		;up
		brne	timer_adj_10
		lds	tempreg1,bas_array+1	;h
		lds	tempreg2,bas_array	;h*10
		inc	tempreg1
		cpi	tempreg1,0x3a		;over
		brne	timer_adj_3
		ldi	tempreg1,0x30
		inc	tempreg2
timer_adj_3:	cpi	tempreg2,0x32		;20
		brne	timer_adj_4
		cpi	tempreg1,0x34		;4
		brne	timer_adj_4
		ldi	tempreg1,0x30
		ldi	tempreg2,0x30
timer_adj_4:	sts	bas_array,tempreg2
		sts	bas_array+1,tempreg1
		ldi	YL,LOW(bas_array)
		ldi	YH,HIGH(bas_array)
		rcall	timer_setg_re
		libi2c_rtc3232_write_time
timer_adj_5:	libmio_sync
		libmio_sync
		libmio_nokey			;wait for key release
		rjmp	timer_adj_2

timer_adj_end:	clr	ctrl
		ldi	tempreg2,3
		rjmp	timer_menus_re
						
timer_adj_10:	cpi	tempreg1,0xe5		;down
		brne	timer_adj_5
		lds	tempreg1,bas_array+1	;h
		lds	tempreg2,bas_array	;h*10
		dec	tempreg1		;h-1
		cpi	tempreg1,0x2f		;over
		brne	timer_adj_4
		ldi	tempreg1,0x39
		dec	tempreg2
		cpi	tempreg2,0x2f
		brne	timer_adj_4
timer_adj_11:	ldi	tempreg1,0x33		;23
		ldi	tempreg2,0x32
		rjmp	timer_adj_4

