;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# stopp_watch									#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

;------------------------------------------------------------------------------
;stopp-watch
;------------------------------------------------------------------------------
timer_stwa:	ldi	ZL,LOW(libmio_icons*2+50)
		ldi	ZH,HIGH(libmio_icons*2+50)
		libmio_appframe
		ldi	XL,46
		ldi	XH,0
		ldi	ZL,LOW(timer_text_5*2)	;text pointer
		ldi	ZH,HIGH(timer_text_5*2)
		libmio_xztext						
						
		libmio_thistext			;inner round edges
		.db	10,11,0xa4,0
		libmio_thistext
		.db	10,111,0xa5,0
		libmio_thistext
		.db	52,11,0xa6,0
		libmio_thistext
		.db	52,111,0xa7,0
		

timer_stwa_2:	ldi	XL,0x01			;set color
		libmio_setcolor
		ldi	YL,11			;separator line
		ldi	YH,35
		ldi	ZL,116
		ldi	ZH,36
		libmio_fbox
		sts	libmio_font,const_1	;small font
		ldi	XL,16
		ldi	XH,12
		ldi	ZL,LOW(timer_text_6*2)	;text pointer
		ldi	ZH,HIGH(timer_text_6*2)
		libmio_xztext						
		ldi	XL,16
		ldi	XH,39
		ldi	ZL,LOW(timer_text_7*2)	;text pointer
		ldi	ZH,HIGH(timer_text_7*2)
		libmio_xztext				
		sts	libmio_font,const_0	;normal font				
		libmio_nokey
		

timer_stwa_3:	clr	ereg			;status=stop
		
timer_stwa_4:	ldi	ctrl,0x09		;write LAP time
		libmio_thistext
		.db	47,36,0,0
		lds	XL,timer_ram
		lds	XH,timer_ram+1
		libmio_outdez
		libmio_outcomma
		ldi	ctrl,0x06
		lds	XL,timer_ram+2
		lds	XH,timer_ram+3
		libmio_outdez
		ldi	tempreg1,'s'
		libmio_outchar

timer_stwa_6:	lds	tempreg1,libmio_tstat
		cpi	tempreg1,2		;run
		brne	timer_stwa_7
		lds	XL,libmio_tmsh		;write time
		cp	XL,tempreg4
		breq	timer_stwa_9
		mov	tempreg4,XL
timer_stwa_7:	ldi	ctrl,0x09
		libmio_thistext
		.db	21,36,0,0
		lds	XL,libmio_tsl
		lds	XH,libmio_tsh
		libmio_outdez
		libmio_outcomma
		ldi	ctrl,0x06
		lds	XL,libmio_tmsl
		lds	XH,libmio_tmsh
		libmio_outdez
		ldi	tempreg1,'s'
		libmio_outchar

timer_stwa_9:	lds	tempreg1,libmio_keycode
		cpi	tempreg1,0
		brne	timer_stwa_10
		clr	ereg
		rjmp	timer_stwa_6
		
timer_stwa_10:	cp	tempreg1,ereg
		breq	timer_stwa_6		;equal
		mov	ereg,tempreg1
		
		cpi	tempreg1,0xed		;ESC
		brne	timer_stwa_11
		ret
		
timer_stwa_11:	cpi	tempreg1,0xea		;start/stop
		brne	timer_stwa_13
		lds	tempreg1,libmio_tstat
		cpi	tempreg1,2		;run
		brne	timer_stwa_12
		sts	libmio_tstat,const_0	;stop
		rjmp	timer_stwa_7
timer_stwa_12:	ldi	tempreg1,2
		sts	libmio_tstat,tempreg1	;start
		rjmp	timer_stwa_7
		
timer_stwa_13:	cpi	tempreg1,0xe4		;RES
		brne	timer_stwa_14
		rcall	timer_stwac
		rjmp	timer_stwa_3
		
timer_stwa_14:	cpi	tempreg1,0xe2		;mem
		breq	timer_stwa_15
		cpi	tempreg1,0xe3		;mem
		brne	timer_stwa_18
timer_stwa_15:	rcall	timer_stwas
		jmp	timer_stwa		


timer_stwa_18:	cpi	tempreg1,0xe5		;LAP
		brne	timer_stwa_9
		cli
		lds	XL,libmio_tsl
		lds	XH,libmio_tsh								
		lds	YL,libmio_tmsl
		lds	YH,libmio_tmsh
		sei
		sts	timer_ram,XL
		sts	timer_ram+1,XH
		sts	timer_ram+2,YL
		sts	timer_ram+3,YH
		rjmp	timer_stwa_4
		
timer_stwac:	ldi	XL,0x40			;reset timer		
		sts	libmio_tstat,XL
timer_stwac1:	lds	XL,libmio_tstat
		cpi	XL,0
		brne	timer_stwac1
		ret
		
;------------------------------------------------------------------------------
;store stoppwatch times (EEPROM base address is 1960)
;------------------------------------------------------------------------------		
timer_stwas0:	ldi	ZL,LOW(timer_swstext2*2)	;text
		ldi	ZH,HIGH(timer_swstext2*2)
		rjmp	timer_stwas_00
timer_stwas:	ldi	ZL,LOW(timer_swstext1*2)	;text
		ldi	ZH,HIGH(timer_swstext1*2)
timer_stwas_00:	lds	XL,libmio_rtc
		push	XL
		andi	XL,0xfd
		sts	libmio_rtc,XL

timer_stwas_01:	libmio_menuheadf			;set menuhead
		libmio_menu4icons			;draw empty icons
		sts	libmio_font,const_1		;little font
		ldi	YL,LOW(1792)			;EE base
		ldi	YH,HIGH(1792)	
		ldi	tempreg4,0			;counter
		
timer_stwas_03:	ldi	XL,8			;X-pos
		ldi	XH,12			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0			;X+64
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		libmio_gotoxy				
		ldi	XL,12			;name len
timer_stwas_04:	libeep_read			;get char
		sbrc	tempreg1,7
		ldi	tempreg1,0x20		;replace with space
		libmio_outchar
		dec	XL
		brne	timer_stwas_04
		ldi	XL,14			;X-pos
		ldi	XH,24			;Y-pos
		sbrc	tempreg4,0
		subi	XL,0xc0			;X+64
		sbrc	tempreg4,1
		subi	XH,0xe4			;+28
		libmio_gotoxy				
		
		ldi	ctrl,0x09		;write LAP time
		libeep_read
		mov	XL,tempreg1
		libeep_read
		mov	XH,tempreg1		
		libmio_outdez
		libmio_outcomma
		ldi	ctrl,0x06
		libeep_read
		mov	XL,tempreg1
		libeep_read
		mov	XH,tempreg1			
		libmio_outdez
		ldi	tempreg1,'s'
		libmio_outchar

		inc	tempreg4
		cpi	tempreg4,4
		brne	timer_stwas_03
		libmio_nokey
		clr	tempreg2
		
timer_stwas_05:	libmio_imenu4			;start selection
		cpi	tempreg1,0xed		;esc
		brne	timer_stwas_06
		sts	libmio_font,const_0	;big font		
		pop	XL
		sts	libmio_rtc,XL
		ret				;back to stopp-watch
			
timer_stwas_06:	ldi	YL,LOW(1792+12)		;EE base+skip name
		ldi	YH,HIGH(1792+12)			
		sbrc	tempreg2,0
		adiw	YL,16
		sbrc	tempreg2,1
		adiw	YL,32	
		
		ldi	ZL,LOW(timer_sstext*2)
		ldi	ZH,HIGH(timer_sstext*2)
		ldi	tempreg2,12
		libmio_newtext	
		brtc	timer_stwas_08		;skip if esc
		sbiw	YL,12			;reset pointer to start of name			
		ldi	ZL,LOW(libmio_tram)
		ldi	ZH,HIGH(libmio_tram)		
		ldi	XL,12
timer_stwas_07:	ld	tempreg1,Z+
		libeep_write
		dec	XL
		brne	timer_stwas_07
;now write time		
timer_stwas_08:	lds	tempreg1,timer_ram	;
		libeep_write
		lds	tempreg1,timer_ram+1	;
		libeep_write
		lds	tempreg1,timer_ram+2	;
		libeep_write
		lds	tempreg1,timer_ram+3	;
		libeep_write				
		rjmp	timer_stwas		;loop		
		
